#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: NetRS.cgi,v 1.138 2006/03/23 00:46:35 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/NetRS.cgi,v $

# NetRS.cgi
# The primary startup script for the Fireball GUI interface.
# Can be started in three modes:
#
#   NetRS.cgi
#       Open interface with default style.
#
#   NetRS.cgi?style=inbrowser
#       Open interface in the existing browser window.
#
#   NetRS.cgi?style=standalone
#       Open interface in a new browser window.
#
#

use strict ;
use CGI qw/:standard/;


########################################################################

# Get the system identifier string from a config file.
my $identityString= qx|cat /etc/sysconfig/sysname| ;
chomp $identityString ;

# Determine a serial number by querying the "warranty" command.
# warranty -s returns:
#   Serial_number: 5432198765
# Extract the numeric string.
my $serialNumber = qx(/usr/bin/sudo /usr/local/fireball/warranty -s) ;
chomp $serialNumber ;   # Drop linefeed
$serialNumber = (split("[ :]+",$serialNumber))[1] ;


print header(-expires=>"+1s") ;

print <<EOF ;
<html xmlns="http://www.w3.org/1999/xhtml"
lang="en-US"><head>
<title>Trimble NetRS $identityString </title> 
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"/>
<meta name="copyright" content="Copyright(c) 2003 Trimble Navigation Ltd." />

<link rel="shortcut icon" href="../images/NetRS.ico">

</head>
EOF



print <<EOF ;
<script>
// The user specified identifying string.
// This can be used by any window for displaying the string.
identityString="$identityString" ;
serialNumber="$serialNumber" ;
</script>
EOF


# These are all of the Application's global javascript functions.
# They can be used from the subframes, by using the
# syntax "parent.fname()".
print <<EOF ;
<script>


//**********************************************************************
function drawMenu( m )
//**********************************************************************
/* Redraws the main menu.  If "level" is non-negative, expand that
 * portion of the menu.
 * If it is -1, no levels will be expanded.
 * This function is designed to be called from within the web page
 * mainMenu.html, which uses normal HTML tags to describe the page
 * and its background color.  That page generates no text in the
 * documentbody, but instead calls this function to dynamically draw the
 * menu.  Note that the mainMenu.html page requires a parent window
 * containing this function, so the menu cannot be loaded into a
 * separate window.
 */
{
    /* Determine the URL location of the parent window, and use that
     * to determine a "prefix" for images and URLs.
     */
    base = parent.location.protocol
         + '//'
         + parent.location.host
         + '/' ;

    images = base + 'images/' ;
    images = '/images/' ;

    // Force the colors of all links to match the user's setting for an
    // unused link.  We don't want used links to change color.  It looks
    // ugly in a menu.
    m.writeln( '<style type="text/css">' ) ;
    m.writeln( '<!--' ) ;
    m.writeln( 'a {color:#ffffff ; text-decoration: none ; '
              //+'font-family:arial ;'
              +'}' ) ;
    m.writeln( '-->' ) ;
    m.writeln( '</style>' ) ;

    // The main menu items are in a list.
    m.writeln( '<table border="0" cellpadding="1">' ) ;

    // Write out each of the main entries.  Expand one if required.
    for (i = 0 ; i < mainLabels.length ; ++i)
    {
      if (mainLabels[i] != "")
      {
        // Create a link containing this main menu item.
        // The URL will call this function with the required level.
        m.write( '<tr><td nowrap>' ) ;
        /*
        m.write( '<a href="javascript:parent.updateMenu(', 
                i ,
               ')">');


        m.write( '<img src="',images,'reddot.gif" border=0></a>' ) ;
        */

        m.write( '<a href="javascript:parent.updateMenu(',i,')" ' ) ;
        m.write( 'style="text-decoration:none" ' ) ;
        m.write( '>') ;

        // Highlight the expanded name.
        //if (level == i) m.write( '<b>' ) ;

        m.writeln( '<b>',mainLabels[i],'</b></a>' ) ;

        m.writeln() ;

        // If this is the expanded level...
        if (level == i)
        {
          // finish the highlighting on the main name.
          //m.write( '</b>' ) ;

          if (subLabels[i].length != 0)
          {
            // Show any sub-menu items.
            for (j = 0 ; j < subLabels[i].length ; ++j)
            {
              m.write( '<tr><td nowrap>&nbsp;' ) ;
              if (subURLs[i][j] != "")
              {
                m.write( '<a href="javascript:parent.loadDataFrame(',
                         "'",
                         subURLs[i][j],"')",'" ');
                m.write( 'style="text-decoration:none" ' ) ;
                m.writeln( '>') ;
              }
              m.write( '<img src="',images,'blueBoxIcon.gif" border=0>' ) ;
              m.write( ' <b>', subLabels[i][j],'</b>' ) ;
              if (subURLs[i][j] != "")
                m.writeln( '</a>' ) ;
              m.writeln() ;
            }
          }
        }
      }
      else
      {
        m.write( '<tr><td>&nbsp;</td></tr>' ) ;
      }
    }
    m.writeln( '</table>' ) ;


} // end of drawMenu()



//**********************************************************************
function updateMenu( newLevel )
//**********************************************************************
/* Respond to a main menu choice.
 * The newLevel parameter describes which of the main menu items should
 * be expanded.  If it is -1, no levels will be expanded.  If it matches
 * the currently expanded level, then we unexpand that level.  If we are
 * opening a level, we activate any attached URL in the dataFrame area.
 * Formerly this routine directly re-drew the contents of the menu
 * frame.  But that had problems.  So now we just tell the menu fram
 * to redraw itself.
 */
{
    // Remember the new level in the global variable.
    level = newLevel ;

    // Tell the menu frame to redraw itself
    frames[2].location.reload() ;

    // If there is a URL attached to the current main menu item,
    // activate that URL in the data frame.
    if ( (level != -1)
      && (mainURLs[level] != "")
       )
    {
      loadDataFrame( mainURLs[level] ) ;
    }

} // end of updateMenu()



//**********************************************************************
function loadDataFrame( url )
//**********************************************************************
/* This function is called whenever one of the menu items desires
 * to load the data frame with a new URL.  This could have been done
 * directly, but having it in a separate function gives us some extra
 * control.  First, we can clear the dataFrame, giving the user
 * immediate visual feedback that the choice has been made, independent
 * of any delays.
 * In addtion, this routine cancels any global refresh timeouts that
 * might have been started with loadAfterDelay().
 */
{
    //alert( url ) ;

    clearTimeout( loadAfterDelayTimer ) ;

    // Clear the current dataframe contents prior to loading in the
    // new data.  This makes it obvious to the user that something is
    // happening.  Without this action, the User might get no feedback
    // that his menu choice was acted on until the new page comes back,
    // which might take several seconds.
    // In the special case where an XML URL is in the window, you can't
    // blank the window. open() and close() aren't defined for that type
    // of window.  In that case we just load the "blankpage" URL.

    if ( (m=dataFrame.document).open != null )
    {
      m.open() ;
      m.close() ;

      // Set the background color to match our standard.
      m.bgColor="fff5e4" ;
    }
    else
    {
      dataFrame.location = '/blankpage.html' ;
    }

    // Load the new URL into the frame, This uses the "replace()" method
    // instead of a direct write of the new URL.  Replace() overwrites
    // the blank-page put in above, so that the Back button works 
    // properly.
    dataFrame.location.replace(url) ;

} // end of loadDataFrame()



/**********************************************************************/
function submitFormWithTag( theForm, url, tag )
/**********************************************************************/
/* There is a form in the dataframe and we want to submit its data
 * to the specified URL.  This could be done directly from the form's
 * page itself, but that has disadvantages.  First, there is often
 * little visual feedback that the submission has occurred.  Second,
 * the page containing the form often stays visible and active in the
 * browser, allowing for double-clicks, extraneous submissions, etc.
 * To solve all of this we want the page to blank immediately on
 * submission.  But then the form data disappears so we can't submit it
 * using the built-in "submit" function.  That's where this function
 * comes in.  We extract the fields from the form and create the
 * URL the browser would have created.  Then we blank the page and
 * submit that URL.  SInce this is all taking place in the parent frame
 * (where this function resides) the URL is preserved even when we blank
 * the dataFrame.
 * Note that this technique may not be completely general.  THus you
 * might be able to come up with a form that contains elements I didn't
 * account for.  If so, then code them in here.
 */
{
  /* If no url is sent, then use the default action from the form. */
  if (url == '')
  {
    url = theForm.action ;
  }

  e = theForm.elements ;
  s = '' ;

  separator = '?' ; // First one of these is a '?'.
                    // Then they become '&'.

  for (i = 0 ; i < e.length ; ++i )
  {
    s += e[i].type + '-' + e[i].name + '=' + e[i].value + '\\n' ;
    if ( e[i].type == 'text' 
      || e[i].type == 'hidden'
      || e[i].type == 'password'
      || (e[i].type == 'radio' && e[i].checked)
      || (e[i].type == 'checkbox' && e[i].checked)
      )
    {
      url += separator 
          + e[i].name 
          + '=' 
          + escape( e[i].value ).replace( /\\+/g, "%2B" ) ;
      separator = '&' ;
    }
    else
    if ( e[i].type == 'radio'
      || e[i].type == 'button'
      || e[i].type == 'checkbox'
       )
    {
      // Radio button Not checked, so don't send it.
      // Or this is a simple "button" which isn't normally sent.
    }
    else
    if ( e[i].type == 'select-one' )
    {
      
      p = e[i].options[e[i].selectedIndex].value ;
      url += separator + e[i].name + '=' + escape(p) ;
      separator = '&' ;
    }
    else
    {
      alert( 'submitForm: problem with ' 
           + e[i].type 
           + '=' 
           + e[i].name 
           ) ;
      return ;
    }
  }

  if (tag != '')
    url += '#' + tag ;

  //alert( s ) ;
  //alert( url ) ;
  loadDataFrame( url ) ;

} /* end of submitFormWithTag() */ 


/**********************************************************************/
function submitForm( theForm, url )
/**********************************************************************/
{
  submitFormWithTag( theForm, url, '' ) ;
}


level = -1 ;
mainlevel = -1 
mainLabels = new Array() ;
mainURLs   = new Array() ;
subLabels  = new Array() ;
subURLs    = new Array() ;

//**********************************************************************
function addMainItem( label, URL )
//**********************************************************************
{
  ++mainlevel ;
  mainLabels[mainlevel] = label ;
  mainURLs[mainlevel] = URL ;
  subLevel = 0 ;
  subLabels[mainlevel] = new Array() ;
  subURLs[mainlevel] = new Array() ;
} // end of addMainItem()



//**********************************************************************
function addSubMenu( label, URL )
//**********************************************************************
{
  subLabels[mainlevel][subLevel] = label ;
  subURLs[mainlevel][subLevel] = URL ;
  ++subLevel ;
} // end of addSubMenu()


addMainItem( "Receiver&nbsp;Status",
             "/perl-scripts/rstatusIdentity.cgi" ) ;
addSubMenu( "Identity",
            "/perl-scripts/rstatusIdentity.cgi" ) ;
addSubMenu( "Activity",
            "/perl-scripts/rstatusActivity.cgi" ) ;
addSubMenu( "Position",
            "/perl-scripts/rstatusPosition.cgi" ) ;

addMainItem( "Satellites",
             "/perl-scripts/satGeneral.cgi" ) ;
addSubMenu( "General",
            "/perl-scripts/satGeneral.cgi" ) ;
addSubMenu( "Tracking",
            "/perl-scripts/satTracking.cgi" ) ;
addSubMenu( "GPS&nbsp;Enable/Disable",
            "/perl-scripts/satEnaDis.cgi" ) ;
addSubMenu( "WAAS",
            "/perl-scripts/waas.cgi" ) ;
addSubMenu( "Data",
            "/perl-scripts/satData.cgi" ) ;

addMainItem( "Data&nbsp;Logging",
             "/perl-scripts/sessions.cgi" ) ;
addSubMenu( "Status",
            "/perl-scripts/sessions.cgi" ) ;
addSubMenu( "AutoDelete",
            "/perl-scripts/autoDelete.cgi" ) ;
addSubMenu( "Power&nbsp;Saving",
            "/perl-scripts/sleepMode.cgi" ) ;
addSubMenu( "Data&nbsp;Files",
            "/perl-scripts/dataFiles.cgi" ) ;

addMainItem( "Receiver&nbsp;Configuration",
             "/perl-scripts/rconfigDisplay.cgi" ) ;
addSubMenu( "Summary",
            "/perl-scripts/rconfigDisplay.cgi" ) ;
addSubMenu( "Antenna",
            "/perl-scripts/antenna.cgi" ) ;
addSubMenu( "Clock&nbsp;Steering",
            "/perl-scripts/clockSteering.cgi" ) ;
addSubMenu( "Multipath",
            "/perl-scripts/multipath.cgi" ) ;
addSubMenu( "L2&nbsp;Tracking",
            "/perl-scripts/L2Tracking.cgi" ) ;
addSubMenu( "Masks",
            "/perl-scripts/masks.cgi" ) ;
addSubMenu( "One&nbsp;Pulse&nbsp;Per&nbsp;Second",
            "/perl-scripts/pps.cgi" ) ;
addSubMenu( "Reference&nbsp;Frequency",
            "/perl-scripts/extRef.cgi" ) ;
addSubMenu( "Configuration&nbsp;Files",
            "/perl-scripts/configFiles.cgi" ) ;
addSubMenu( "Shutdown Voltage",
            "/perl-scripts/vsleep.cgi" ) ;
addSubMenu( "System Reset",
            "/perl-scripts/reset.cgi" ) ;

addMainItem( "Internet",
             "/perl-scripts/internetEthernet.cgi" ) ;
addSubMenu( "Ethernet",
            "/perl-scripts/internetEthernet.cgi" ) ;
addSubMenu( "HTTP",
            "/perl-scripts/http.cgi" ) ;
addSubMenu( "IP Filtering",
            "/perl-scripts/iptables.cgi" ) ;
addSubMenu( "FTP",
            "/perl-scripts/ftp.cgi" ) ;
addSubMenu( "NTP Client",
            "/perl-scripts/ntp.cgi" ) ;

addMainItem( "I/O&nbsp;Configuration",
             "/perl-scripts/portSummary.cgi" ) ;
addSubMenu( "Port&nbsp;Summary",
            "/perl-scripts/portSummary.cgi" ) ;
addSubMenu( "Port&nbsp;Configuration",
            "/perl-scripts/portSetup.cgi" ) ;
addSubMenu( "Reference&nbsp;Station",
            "/perl-scripts/refpos.cgi" ) ;
addSubMenu( "Client&nbsp;Authentication",
            "/perl-scripts/clientAuth.cgi" ) ;
addSubMenu( "Port&nbsp;Advertising",
            "/perl-scripts/advertise.cgi" ) ;
addSubMenu( "PPP&nbsp;Dialout",
            "/perl-scripts/sysadmin/pppDialout.cgi" ) ;

addMainItem( "Security",
             "/perl-scripts/access.cgi" ) ;
addSubMenu( "Access",
            "/perl-scripts/access.cgi" ) ;
addSubMenu( "Accounts",
            "/perl-scripts/sysadmin/accounts.cgi" ) ;
addSubMenu( "Change&nbsp;Password",
            "/perl-scripts/changePassword.cgi" ) ;

addMainItem( "Firmware",
             "/perl-scripts/firmware.cgi" ) ;
addSubMenu( "Status",
            "/perl-scripts/firmware.cgi" ) ;
addSubMenu( "Upload",
            "/perl-scripts/sysadmin/firmwareUpload.cgi" ) ;
addSubMenu( "Warranty Date",
            "/perl-scripts/warranty.cgi" ) ;

addMainItem( "Programmatic Interface",
            "/perl-scripts/progTest.cgi" ) ;

addMainItem( "","" ) ;

if ( window.name != "B$serialNumber" )
{
  addMainItem( "In Browser",
               "javascript:parent.restartInBrowser()" ) ;
}

if ( window.name != "S$serialNumber" )
{
  addMainItem( "Standalone Window",
               "javascript:parent.restartStandalone()" ) ;
}

/* Start the menu system with the first menu main item expanded. */
level = 0 ;


//**********************************************************************
function showHelp( url )
//**********************************************************************
/* This function can be called from any of the data windows, giving the
 * URL of a help page to be displayed in a separate window named
 * "FBinfo".
 *
 * The FBinfo window will have only the toolbar (Back/Forward/Print,
 * etc.) but no location-toolbar (for URL display/entry) and no
 * directories-toolbar (hotlinks, etc.).  Its primary utility is to be
 * able to navigate and print the help screens.
 */
{
  w = window.open(url,"FBinfo","toolbar,menubar,resizable,scrollbars");

  // Make sure the info window pops to the top when new data is loaded
  // into it.
  w.focus() ;
} // end of showHelp()



/* Create a global variable that holds a reference to the global
 * timer used for auto-refresh functionality.  This allows for existing
 * timeouts to be cleared when new ones are being set.  Although the
 * variable probably doesn't need to be initialized, I do that here
 * just to be safe so that ClearTimeout() won't complain if called
 * with a non-timer parameter.
 */
loadAfterDelayTimer = setTimeout( '', 1 ) ;

//**********************************************************************
function loadAfterDelay( url, msecs )
//**********************************************************************
/* This utility function can be called by a page in the dataFrame,
 * to schedule a refresh of the dataFrame contents after a specified
 * delay.  Typically the same URL would be loaded in (a refresh) but
 * the function can also be used to switch to an alternate page after
 * the delay.
 *
 * Although this could be accomplished directly in the individual pages,
 * using this global function provides uniformity.  Furthermore, the
 * timer has to be canceled when other pages are selected before the
 * timeout elapses so having the individual pages handle that is risky.
 *
 * Rather than just setting the location after the timeout, we call
 * a function delayDone(), which is fed two parameters.  The first is
 * the URL we want loaded in.  The second is the current URL value.
 * This is read here and saved in the timeout command.  DelayDone()
 * checks that the dataFrame is still on the original location before
 * doing the update.  That prevents page changes, say due to the
 * Back-button from being overwritten by the timeout.
 */
{
  clearTimeout(loadAfterDelayTimer) ;

  oldurl = dataFrame.location ;

  /* Set the timeout, giving the command to be executed and how long to
   * wait.  We have to carefully construct the command as a single
   * string.  The final result should look like:
   *    delayDone( "urlString", "oldUrlString" )
   * 
   */
  loadAfterDelayTimer= setTimeout( 'delayDone( "' 
                                   + url 
                                   + '","'
                                   + oldurl 
                                   + '")'
                                   , msecs ) ;
} /* end of loadAfterDelay() */



//**********************************************************************
function delayDone( newurl, oldurl )
//**********************************************************************
/* delayDone() is used by loadAfterDelay() to implement the final switch
 * of the dataFrame page after the delay is done.  It checks that the
 * dataFrame is still showing the original page, and if so, it switched
 * to the new url location (which may be the same == a refresh).
 * Checking the oldurl is done to ensure that the timeout gets ignored 
 * if the user manages to change the original page first.
 */
{

  if (dataFrame.location == oldurl)
  {
    // Still on original location.  Go ahead and update the frame.
    // We use the replace() function instead of directly writing
    // to the location, so that the new URL overwrites the current
    // location in the history buffer.  This makes the Back Button
    // work better.
    dataFrame.location.replace( newurl ) ;
  }

} /* end of delayDone() */



//**********************************************************************
function restartStandalone()
//**********************************************************************
/* Open a standalone application window.  Fill it with a re-invocation
 * of this script.  The window is given a name of this Fireball's 
 * serial number.  That lets us close the window later, if we switch to
 * an Inbrowser style.
 */
{
  // Ideally we'd like the standalone window to be opened with a 
  // prefered size.  Sadly, some old browsers (NS4.7) won't let you do 
  // this with a single call to window.open().  Experimentally we
  // found that multiple opens, as below, will do the job, and this
  // seems to work on all browsers.

  window.open( "",
               "S$serialNumber",
               "status,resizable,outerwidth=800,outerheight=600") ;
  window.open( "",
               "S$serialNumber",
               "status,resizable,outerwidth=800,outerheight=600") ;
  w=window.open( "/perl-scripts/NetRS.cgi",
                 "S$serialNumber",
                 "status,resizable,outerwidth=800,outerheight=600") ;
  w.focus() ; // Bring to the top of the windows stack.

  // If we are currently in a window started with the Inbrowser 
  // setting, it will be named "B"serialnumber (starting with a B).
  // If we are switching to the standalone from that type of window,
  // we close the Inbrowser version.
  if (window.name == "B${serialNumber}") 
    self.close() ;
  else
    updateMenu( 0 ) ;
} // end of restartStandalone()



//**********************************************************************
function restartInBrowser()
//**********************************************************************
/* Open an InBrowser application window (with the usual browser
 * decorations, tool bars, etc.).  Fill it with a re-invocation
 * of this script.  The window is given a name of this Fireball's 
 * serial number followed by a "B".  That lets us close the window
 * later, if we switch to a Standalone style.
 */
{
  w=window.open( "/perl-scripts/NetRS.cgi", 
                 "B$serialNumber"
               ) ;
  w.focus() ; // Bring to the top of the windows stack.

  // If we are currently in a window started with the standalone 
  // setting, it will be named "S"+serialnumber.
  // If we are switching to the InBrowser from that type of window,
  // we close the standalone version.
  if (window.name == "S${serialNumber}") 
    self.close() ;
  else
    updateMenu( 0 ) ;

} // end of restartInBrowser()



//**********************************************************************
function updateSerialNumber( sn )
//**********************************************************************
/* Called from the GUI when the serial number has changed.
 * We just preserve the new value in the static javascript variable in
 * the parent window, and refresh the title bar, which displays the
 * new value.
 */
{
  serialNumber = sn ;
  title.document.location = '/title.html' ;
} // end of updateSerialNumber()


//**********************************************************************
function updateSysname( name )
//**********************************************************************
/* Called from the GUI when the system name has changed.
 * We just preserve the new value in the static javascript variable in
 * the parent window, and refresh the title bar, which displays the
 * new value.
 */
{
  identityString = name ;
  title.document.location = '/title.html' ;
} // end of updateSerialNumber()



titleClicks = 0 ;
//**********************************************************************
function titleClick()
//**********************************************************************
/* Called whenever the user clicks on the Trimble Logo in the Title 
 * subframe.  These clicks are counted.  After five of them we activate
 * the test menu.
 */
{
  if (++titleClicks == 5 ) 
  {
    addMainItem( "Testing",
                 "/perl-scripts/syslogs.cgi" ) ;
    addSubMenu( "System&nbsp;Logs",
                "/perl-scripts/syslogs.cgi" ) ;
    addSubMenu( "Production&nbsp;Test&nbsp;Results",
                "/perl-scripts/testResults.cgi" ) ;
    addSubMenu( "Stinger",
                "/perl-scripts/sysadmin/stingerTest.cgi" ) ;
    addSubMenu( "Streams",
                "/perl-scripts/streamStatus.cgi" ) ;
    addSubMenu( "Sysinfo",
                "/perl-scripts/sysinfo.cgi" ) ;
    addSubMenu( "Disk Tests",
                "/perl-scripts/sysadmin/diskTests.cgi" ) ;
    updateMenu( mainlevel ) ;
  }
} /* end of titleClick() */



/**********************************************************************/
function isNotAnInteger( s, label )
/**********************************************************************/
/* Examines string 's' to determine if it represents an integer
 * containing nothing but digits 0 to 9, exclusive of leading or
 * trailing spaces.
 * If it is an integer, returns false.
 * If it IS NOT an integer, returns true, but first posts a warning
 * alert using the 'label' of the form:
 *      label must be a positive integer.
 */
{
  bad = false ;
  s = strip(s) ;
  intval = parseInt(s) ;

  if ( isNaN(intval)) bad = true ;

  for (i = 0 ; i < s.length ; ++i)
  {
    c = s.charAt( i ) ;
    if ( c < '0' || c > '9') bad = true ;
  }

  if (bad)
  {
    alert( label + " must be a positive integer.") ;
    return true ;
  }
  else
    return false ;
} /* end of isNotAnInteger() */



/**********************************************************************/
function badFixedPointNumber( s ) 
/**********************************************************************/
/* Returns true if 's' ISN'T a valid fixed-point number string. 
 * Checks s against two regular expressions:
 *      d[ddd][.][dddd]
 *      .d[dddd]
 */
{
  return ( ! s.match( /^[0-9]+\.?[0-9]*\$/ )
        && ! s.match( /^\.[0-9]+\$/ )
         ) ;
} /* end of badFixedPointNumber() */



/**********************************************************************/
function notValidIP( s )
/**********************************************************************/
/* Examine string s to determine if it isn't a valid IP4 address.  
 * Tests against the form 155.63.21.25 (n.n.n.n).
 * Returns true if it ISN'T a valid IP.
 */
{
  s = strip( s ) ;  // Remove leading or trailing spaces

  /* Does the string match the basic x.x.x.x pattern.  
   * {1,3} : Only 1-to-3 digits in each section. 
   * ([0-9]{1,3})The parentheses extract each numeric portion into
   * values for later examination, in RegExp.$1, $2, etc.
   */
  if ( !( s.match( 
          /^([0-9]{1,3})\\.([0-9]{1,3})\\.([0-9]{1,3})\\.([0-9]{1,3})\$/
                 ) 
        ) 
     )
    return true ; // Doesn't match the basic pattern.

  /* Test the individual fields for 0 to 255.  Return true if any of
   * them are too large.
   */
  return ( (RegExp.\$1 > 255) 
        || (RegExp.\$2 > 255) 
        || (RegExp.\$3 > 255) 
        || (RegExp.\$4 > 255) 
         )
} /* end of notValidIP() */



/**********************************************************************/
function strip( s )
/**********************************************************************/
/* Strip leading and trailing spaces from the string s.
 * Returns a copy of the string without the spaces.
 */
{
  while ( (s.length > 1)
       && (s.charAt(0) == " ")
        )
  {
    s = s.substring(1,s.length) ;
  }

  while ( (s.length > 1)
       && (s.charAt(s.length-1) == " ")
        )
  {
    s = s.substring(0,s.length-1) ;
  }

  if ( (s.length == 1)
    && (s.charAt(0) == " ")
     )

    s = "" ;
  //alert( "-" + s + "-" ) ;
  return s ;

} /* end of strip() */


</script>
EOF



# If the initial URL is is NetRS.cgi?style=standalone, then the 
# user wants the standalone application to be invoked.  This is possible
# using the Standalone-link in the title bar, but if he wants that as
# the default, say in a bookmark, this is the method.
# Regardless, we'll open an application frameset in the main window
# as well.
if (param("style") && param("style") eq "standalone")
{
  print "<script> restartStandalone() ; </script> " ;
}

# Open up the frames in the current window.

print <<EOF ;

<frameset rows="87,10,*" name="top" framespacing="0" frameborder="NO" border="0">

  <frame src="/title.html" name=title noresize scrolling=no border=0>
  <frame src="/dropshadow.html" name=dropshadow noresize scrolling=no border=0>

  <frameset cols="209,*" name="bottom" framespacing="0" frameborder="NO"
  border="0">
    <frame src="/mainMenu.html" name=mainMenu noresize border=0> 
    <frame src="/perl-scripts/rstatusIdentity.cgi" name="dataFrame" noresize> 
  </frameset>
</frameset>

</html>
EOF


EXIT:

########################################################################
# end of file NetRS.cgi
########################################################################
