#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: PerlStartup.pl,v 1.1 2003/10/31 00:17:33 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/PerlStartup.pl,v $

########################################################################
# PerlStartup.pl
#  This script is designed to be called by the Apache server when the
#  modperl modules is first started up, as with the configuration
#  directive:
#
# PerlRequire "/usr/local/apache/htdocs/fireball/perl-scripts/PerlStartup.pl"
#
# This gives each httpd daemon a headstart on reading in and compiling
# the large perl Library files that contain numerous useful functions.
# Although this gives an initial startup delay before the web server(s)
# can be be used, this is usually done at a time when there isn't any
# activity.  Thus, the user never sees the delay.  If we didn't do
# this, then the user would see the delay at his first access time, and
# possibly think something was wrong.  Or the first Programmatic command
# that was issued would take a long time (perhaps 15 seconds!) to
# respond.  Regardless of where the delay occurs, it has to occur
# somewhere, and we might as well get it over with quickly.
# 
# In our case, we just want this script to read in three libraries,
# one for the Perl CGI stuff, one for shared GUI&programmatic stuff, 
# and one for the programmatic interface functions.  Because the
# 'working directory' isn't well defined when this script is called, we
# have to use explicit 'lib' directives to tell Perl where to find the
# last two modules.  
#
# Other initialization stuff could be done here as well, but we'll have
# to see if that makes sense as we go along.
########################################################################


use CGI qw/:standard/;

use lib '/usr/local/apache/htdocs/fireball/perl-scripts/' ;
use Fireball ;
use lib '/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/' ;
use Commands ;

return 1 ;
