#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: clientAuth.cgi,v 1.2 2004/09/03 15:43:38 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/clientAuth.cgi,v $

########################################################################
# clientAuth.cgi
#
# Script to allow setting the key for I/O client authentication.
# Called with no CGI parameters. 
# We put up a form waiting for double-entry of the key.
# When the user hits "OK" we check the entries with javascript and
# submit the new password to the script sysadmin/setClientAuth.cgi.
#
########################################################################


use CGI qw/:standard/;
use strict ;
use Fireball ;

titleWithHelp( 'Client Authentication Key',
               '/clientAuthInfo.html'
             ) ;
           
           
# Create the form with fields for key entry.
# A table is used to align labels, text entry fields, and the button on
# a central line.
print startform( -name=>"theForm", 
                 -action=>'/perl-scripts/sysadmin/setClientAuth.cgi'
               ) ;

print <<EOF ;
This key is used for TCP, UDP, and REP ports that use client
authentication.
<br />
<br />
EOF

print table( 
             Tr( th( {-align=>'right'}, 'Key' ),
                 td( {-align=>'left'},
                     password_field( 'key1', '', 14, 7 ) 
                   ),
                 td( "&nbsp;&nbsp;Must be seven non-space characters." ) 
               ) ,

             Tr( th( {-align=>'right'}, 'Re-Enter Key' ),
                 td( {-align=>'left'},
                     password_field( 'key2', '', 14, 7 ) 
                   )
               ) ,
             Tr( td("&nbsp;") ) ,

             Tr( td( '' ),
                 td( submit( "change", "OK" ),
                     button( -name=>'Cancel', 
                             -value=>'Cancel',
                             -onClick=>
                             'parent.loadDataFrame( "portSummary.cgi" )'
                           )
                   )
                 
               ) ,
           ) ;

print endform() ;


print end_html() ;

########################################################################
# end of file clientAuth.cgi
########################################################################
