#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: clockSteering.cgi,v 1.7 2003/07/16 20:33:57 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/clockSteering.cgi,v $

########################################################################
# clockSteering.cgi
#
# Provides a method to control the Clock Steering function of Stinger.
# Stinger GPS measurements can be adjusted so that they appear to have
# been taken on a system with close to zero clock bias.  This is under
# control of a stinger configuration value "clock_steering".  This
# can be set by using the command
#   put clock_steering [off|on]
# Likewise "get clock_steering" on the info channel will provide that
# value back to you.
#
# This script is called to put up the HTML form for controlling the
# clock steering function.  No CGI parameters are used.  When the user
# clicks on OK, the script gpsadmin/setClockSteering.cgi is called with
# the desired setting to activate the change.  Only the
# setClockSteering.cgi script has access restrictions.  This script
# (clocksteering.cgi) is not restricted and anyone can view the form it
# creates.
#
########################################################################


use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'Clock Steering Control',
                         '/clockSteeringInfo.html'
                       ) ;

# Obtain current setting from gpsinfo system, using sysinfo.
# Response will be of the forms:
#  put clock_steering on 
#  put clock_steering off
$_ = qx( /usr/local/fireball/sysinfo -p clock_steering ) ;
chomp ;

#print $_, br() ;

my (undef, undef, $CSstate) = split( " ", $_ ) ;

print startform( -name=>'theForm', 
                 -action=>'/perl-scripts/gpsadmin/setClockSteering.cgi'
               ) ;


my @Control = radio_group( -name=>'clockSteering', 
                           -value=>[ 'on', 'off' ],
                           -nolabels=>1,
                           -default=> $CSstate
                         ) ;

print table( {border=>'1'},
             Tr(
                td( {width=>'30', align=>'center'}, $Control[0] ),
                td( b('Enabled'),br(),
                    'Clock Steering will be used to reduce clock '.
                    'offset to near zero.'
                  )
               ),
             Tr(
                td( {align=>'center'}, $Control[1] ),
                td( b('Disabled'),
                    br(),
                    'Clock Steering will not be used.  Clock bias on '.
                    'measurements and positions can be up to '.
                    '500 microseconds and will drift with time.'
                  )
               )
           ) ;

print br(),hr() ;


# No action was done. In other words this invocation is just 
# displaying the form for accepting new data.  Put up the buttons.
print button( -name=>'OK', 
              -value=>'OK',
              -onClick=>'parent.submitForm( document.theForm, "" )'
            ) ;
print '&nbsp;' ;
print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
            'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" )'
            ) ;

print endform() ;

 
print end_html() ;

########################################################################
# end of file clockSteering.cgi
########################################################################
