#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: download.cgi,v 1.4 2004/04/08 22:56:12 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/fileaccess/download.cgi,v $

########################################################################
# download.cgi
#
# CGI script for downloading logged data files.
#
# Called with a psuedo-url of the form:
#
#   http://netrsname/download/path/to/file
#
# That looks like a regular URL that would download a file or attempt
# to display it in a browser.  But the url gets redirected by the httpd
# server to call this script, with no CGI parameters.  However, the
# original URL is available in the environment variable SCRIPT_NAME.
# That allows us to extract the 'path/to/file' portion and determine
# which file is actually being requested.  
#
# This complexity is forced on us by a bug in InternetExplorer 6,
# which can't handle the Content-Disposition header field properly.
# We formerly just did this with normal CGI parameters.
# See SPR 319 for details on the problems this caused.
#       
# The Logged Data files are rooted at /var/gps/.  This script sends
# back the data file, with an http header that requests a browser to
# save the data into a file on the browsing computer.  The default file
# name (for the save operation on the browser) is now derived strictly 
# by the browser, from the URL.  
########################################################################

use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;

# Extract the partial path to the requested file from the environment
# variable.  We could also use REQUEST_URI, but that variable has 
# HTTP escaped characters still encoded.  The SCRIPT_NAME value should
# look something like:
#   /download/the/path/to/file
# We'll drop the /download/ portion and replace that with /var/gps.

my $path = $ENV{'SCRIPT_NAME'} ;
$path =~ s|^/download/|/var/gps/| ;

# Send back the requested file.  Do this with a technique that
# requests the client system to download and save the file.
sendBinaryFile( $path ) ;

########################################################################
# end of script download.cgi
########################################################################
