#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: ftp.cgi,v 1.13 2004/07/22 23:00:03 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/ftp.cgi,v $

########################################################################
# perl-scripts/ftp.cgi
#
# This script displays the current state of the FTP system.
#
# A "MODIFY" button starts the data entry process to select a
# different mode or change the setup parameters.
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'FTP Configuration',
               '/ftpInfo.html'
             ) ;

# Read the current FTP controls into a hash.
# There will be elements for 
#   standardPort = [ yes, no ]
#   alternatePort = [1024...65535]
#   anon  = ['disabled' 'enabled' 'enabledDelete']
#   named = ['disabled' 'enabled' 'enabledDelete']
#   admin = ['disabled' 'enabled']
#   namedPassword = Encrypted password for user netrsFTP
#   adminPassword = Encrypted password for user adminFTP
my %ftpSetup ;
getFtpSetup( \%ftpSetup ) ;

print '<Table border="0"> <tr>' ;

print th( {align=>'right'}, 'Anonymous FTP :') ;
print td( {align=>'left'},
          'For user "<b>anonymous</b>" or "<b>ftp</b>" :',
          '<br />Download of logged data files is ',
          ( ($ftpSetup{ 'anon' } eq 'disabled')
            ? '<b>Disabled</b>.'
            : '<b>Enabled.</b>'.
              '<br />File deletion is <b>'.
              ( $ftpSetup{ 'anon' } eq 'enabledDelete' 
                ? 'Enabled</b>.'
                : 'Disabled</b>.' 
              )
          )
        ) ;
print '</tr><tr><td>&nbsp;</td></tr>' ;

print th( {align=>'right'}, 'Named FTP :') ;
print td( {align=>'left'},
          'For user "<b>netrsFTP</b>" :',
          '<br />Download of logged data files is ',
          ( ($ftpSetup{'named'} eq 'disabled')
            ? '<b>Disabled</b>.'
            : '<b>Enabled.</b>'.
              '<br />File deletion is <b>'.
              ( ($ftpSetup{ 'named' } eq 'enabledDelete')
                ? 'Enabled</b>.'
                : 'Disabled</b>.' 
              )
          )
        ) ;

print '</tr><tr><td>&nbsp;</td></tr>' ;

print th( {align=>'right'}, 'Administration FTP :') ;
print td( {align=>'left'},
          'For user "<b>adminFTP</b>" :',
          '<br />Upload of firmware files is ',
          ( ($ftpSetup{'admin'} eq 'enabled')
            ? '<b>Enabled.</b><br />File deletion is <b>Enabled</b>.' 
            : '<b>Disabled</b>.'
          )
        ) ;
print '</tr><tr><td>&nbsp;</td></tr>' ;

if ( $ftpSetup{'ftpEnabled'} eq 'yes' )
{
  print Tr( th( {align=>'right'}, 'FTP Server Listens on :'),
            td( {align=>'left'},
                ( $ftpSetup{'standardPort'} eq 'yes'
                  ? 'Standard <b>Port 21</b>.'
                  : 'Alternate <b>Port '
                   .$ftpSetup{'alternatePort'}
                   .'</b>'
                )
              )
          ) ;
}
else
{
  print Tr( th( {align=>'right'}, 'FTP Server is :'),
            td( {align=>'left'}, '<b>Disabled</b>' )
          ) ;
}

print '</Table><br />' ;



# Start the form portion of the page.
print startform() ;

print button( -name=>'Modify', 
              -value=>'Modify',
              -onClick=>
       'parent.loadDataFrame( "/perl-scripts/sysadmin/ftpConfig.cgi" ) '
            ) ;
print endform() ;


print end_html() ;

########################################################################
# End of script ftp.cgi
########################################################################
