#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: deletePort.cgi,v 1.7 2003/10/24 06:10:46 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/deletePort.cgi,v $

########################################################################
# deletePort.cgi:
#
# Script to Remove an existing I/O port configuration.  The non-secured
# script /perl-scripts/portSetup.cgi is used to put up an HTML form
# for use in defining I/O ports.  When the user clicks Delete on the
# page with an existing TCP/UDP port definition, the
# form's parameters are passed into this script, which is gpsadmin
# secured.  Here we verify the request and then remove the port by
# updating the gpssd configuration files.
#
# The only CGI parameter that is important to this script is 'thePort',
# which defines which port is being deleted.  All other parameters
# are ignored.
#
########################################################################

use strict ;
use CGI qw/:standard/;


use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Delete Port' ) ;


# List parameters
#if (param())
#{
#  print '<PRE>' ;
#  for my $i (param())
#  {
#    print "$i = ", param($i),"\n";
#  }
#  print '</PRE>' ;
#}


# We are going to delete this TCP/UDP stream from the 
# gpssd.config file.  This will just require filtering the
# file to drop the entry associated with the appropriate port.
my $thePort = param( 'thePort' ) ;

if ( $thePort !~ /SerialPort/ ) 
{
  # Read in the data from the configuration files and put in a Hash.
  my %allPortData ;
  getPortSetup( \%allPortData ) ;

  # Remote this port's data.
  delete( $allPortData{$thePort} ) ;

  # Regenerate the configuration file without this port.
  saveGpssdConfig( \%allPortData ) ;
}


# After a timeout, go back to main Sessions screen.
print <<EOF;
  <h2>$thePort has been deleted.</h2>
  Switching to I/O Configuration Display.
  <Script>
  setTimeout( 'document.location = "/perl-scripts/portSummary.cgi"',
              1000
            ) ;
  </Script>
EOF
# Done with page.  Skip the rest of this perl script.  
print end_html() ;


########################################################################
# End of file deletePort.cgi
########################################################################
