#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setAutoDelete.cgi,v 1.6 2003/12/16 18:14:44 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setAutoDelete.cgi,v $

########################################################################
# setAutoDelete.cgi
#
# Finalizes a user choice for the AutoDelete control.
# Typically called from perl-scripts/autoDelete.cgi when the user has
# clicked the OK button.  That submits the form information to this
# script, with a single parameter:
#
#       Enable   = 'yes' or 'no'
# 
# The new setting is saved in a configuration file -
# /etc/sysconfig/autoDelete, which contains a single line with 'yes'
# or 'no'.
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set AutoDelete' ) ;


#for my $p (param())
#{
#  print "$p = ",param($p),br() ;
#}


my %autoDeleteControls ;

for my $pool ('Reserved','a'..'z','Default')
{
  if ( my $size = param("size_$pool") )
  {
    $autoDeleteControls{$pool}{'size'} = $size ;
    $autoDeleteControls{$pool}{'enable'} = param( "enable_$pool" ) 
                                         ? 1 
                                         : 0 ;
  }
}

#print '<pre>' ;

saveAutoDeleteControls( \%autoDeleteControls ) ;

#print qx( cat /etc/sysconfig/autoDelete ) ;
#print '</pre>' ;

# Indicate what the new control is set to.
print h2('AutoDelete changes accepted.' ) ;

# Switch back to the Sessions display page.
print '<Script>parent.loadAfterDelay( "/perl-scripts/sessions.cgi", 
                                      2000);</Script>' ;

print end_html() ;

########################################################################
# end of script setAutoDelete.cgi
########################################################################
