#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setClockSteering.cgi,v 1.6 2004/05/27 00:00:32 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setClockSteering.cgi,v $

########################################################################
# setClockSteering.cgi
#
# Sets the control for the Clock Steering function.
# The control state in the configuration file is adjusted to match 
# the supplied parameter.  Stinger is informed of the change.
#
# The parameters are:
#   clockSteering : 'on' or 'off'
#
# Stinger is controlled by using the command
#
#       put clock_steering [off|on]
#
# The 'put clock_steering [on|off]' string is saved in 
# /etc/sysconfig/stinger.cfg to provide non-volatile storage.
# 
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Clock Steering' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


my $CSstate = param( 'clockSteering' ) ;
if ($CSstate =~ m/^on|off$/ )
{
  newStingerConfig( "put clock_steering $CSstate\n" ) ;

  print h2( "Clock Steering has been ",
            $CSstate eq 'on'
            ? 'enabled.'
            : 'disabled.'
          ) ;

  # After a timeout, go back to main satellite screen.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 2000) ;
    </Script>
EOF
}

print end_html() ;

########################################################################
# end of file setClockSteering.cgi
########################################################################
