#!/usr/bin/perl -w
# Copyright (c) 2006 Trimble Navigation Limited
# $Id: setL2Tracking.cgi,v 1.2 2006/03/23 00:56:35 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setL2Tracking.cgi,v $

########################################################################
# setL2Tracking.cgi
#
# Sets the control for the L2 Tracking function.
# The control state in the configuration file is adjusted to match 
# the supplied parameter.  Stinger is informed of the change.
#
# The parameters are:
#   L2Tracking : 'off' 'enigma' 'l2c_or_enigma' 'l2c_and_enigma'
#
# Stinger is controlled by using the command
#
#       put l2_mode [off|enigma|l2c_or_enigma|l2c_and_enigma]
#
# The 'put l2cs_mode' string is saved in 
# /etc/sysconfig/stinger.cfg to provide non-volatile storage.
# 
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set L2Tracking' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


my $L2state = param( 'L2Tracking' ) ;
if ($L2state =~ m/^enigma|l2c_or_enigma|l2c_and_enigma|off$/ )
{
  newStingerConfig( "put l2_mode $L2state\n" ) ;

  print h2( "L2 Tracking has been set to",
            $L2state eq 'off' 
            ? 'Off'
            : $L2state eq 'enigma'
              ? 'L2-Y-code Only'
              : $L2state eq 'l2c_or_enigma' 
                ? 'L2C or L2-Y-code'
                : 'L2C and L2-Y-code'
          ) ;

  # After a timeout, go back to main satellite screen.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 2000) ;
    </Script>
EOF
}

print end_html() ;

########################################################################
# end of file setL2Tracking.cgi
########################################################################
