#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setMasks.cgi,v 1.7 2004/05/27 00:00:32 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setMasks.cgi,v $

########################################################################
# setMasks.cgi
#
# CGI script to implement the setting of the PDOP and Elevation masks.
# Called from perl-scripts/masks.cgi with parameters like this:
#
#   setMasks.cgi?elevMask=10&pdopMask=7
#
# In response, this script parses the parameters, updates the 
# stinger configuration file, puts up an "Okay, I did it" message, and
# then switches back to the rconfigDisplay page.
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Masks' ) ;

#print( '<BR>Parameters Received:<BR>' ) ;
#foreach my $p (param())
#{
#    print( "$p=", param($p), '<BR>' ) ;
#}
#print '<BR>' ;


my $elevMask = param('elevMask') ;
my $pdopMask = param('pdopMask') ;

if ( defined( $elevMask )
 and defined( $pdopMask) 
 and ($elevMask ne '') 
 and ($pdopMask ne '') 
   )
{
  print h2( "Changing Elevation Mask to $elevMask" ) ;
  print h2( "Changing Pdop Mask to $pdopMask" ) ;

  newStingerConfig( "put elev_mask $elevMask\n" ) ;

  newStingerConfig( "put pdop_mask $pdopMask\n" ) ;

  print <<EOF;
      <Script>
      parent.loadAfterDelay( 'rconfigDisplay.cgi', 1000) ;
      </Script>
EOF

}
else
{
  print h2('Invalid Parameters to setMasks.cgi' ) ;
}

print end_html() ;

########################################################################
# end of file setMasks.cgi
########################################################################
