#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setMultipath.cgi,v 1.7 2004/05/27 00:00:32 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setMultipath.cgi,v $

########################################################################
# setMultipath.cgi
#
# Sets the control for the Multipath function.
# The control state in the configuration file is adjusted to match 
# the supplied parameter.  Stinger is informed of the change.
#
# The parameters are:
#   Multipath : 'on' or 'off'
#
# Multipath in Stinger is controlled by using the command
#
#       put everest [off|on]
#
# The 'put everest [on|off]' string is saved in 
# /etc/sysconfig/stinger.cfg to provide non-volatile storage.
# 
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Multipath' ) ;


#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p = ", param($p), "\n" ;
#}
#print '</PRE>' ;


my $MPstate = param( 'Multipath' ) ;
if ($MPstate =~ m/^on|off$/ )
{
  newStingerConfig( "put everest $MPstate\n" ) ;

  print h2( "Multipath Reduction has been ",
            $MPstate eq 'on'
            ? 'enabled.'
            : 'disabled.'
          ) ;

  # After a timeout, go back to main configuration summary page.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 1000) ;
    </Script>
EOF
}

print end_html() ;

########################################################################
# end of file setMultipath.cgi
########################################################################
