#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setPps.cgi,v 1.8 2004/05/27 00:00:32 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setPps.cgi,v $

########################################################################
# setPps.cgi
#
# Accepts new controls for the Pulse-Per-Second feature.
# This script is called from the perl-script/pps.cgi script, when the
# user uses "OK" to accept new parameters for controlling the PPS
# setup.  The form data is submitted to this CGI script.
# The stinger control state is changed to match the settings.  The
# parameters are:
#   PpsEnable  either 'On' or 'Off '
#   PpsSlope   either 'Positive' or 'Negative'.
#
# For example, the url might look like:
#
#   perl-scripts/gpsadmin/setPps.cgi?PpsEnable=On&PpsSlope=Negative
#
# The pps configuration is saved in a line from 
# /etc/sysconfig/stinger.cfg.  The line is of the forms: 
#
#   put pps_mode on pos
#   put pps_mode off neg
#
# That same format is used for direct control of Stinger using the
# socket connections.  
#
# NOTE ON SLOPE...  The hardware driver in NetRS (and some other
# products) is unable to generate a negative-going pulse.  Thus, NetRS
# can only support a positive slope pulse.  We'll preserve the Stinger
# fiction that we can do both, but the GUI and Programmatic interface
# will no longer provide an option for negative slope/negative pulse.
#
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set PPS' ) ;

#print '<PRE>' ;
#foreach my $p (param())
#{
#  print "$p ", param($p), "\n" ;
#}

my $ppsEnable = param( 'PpsEnable' ) ;

if ( defined( $ppsEnable )
 and ($ppsEnable ne '') 
   )
{
  print h2( 'Pulse Per Second output is ',
            ($ppsEnable eq 'On') ?  'Enabled.' : 'Disabled.'
          ) ;

  newStingerConfig( 'put pps_mode '
                    .( ($ppsEnable eq 'On') ? 'on' : 'off' )
                    ." pos\n"
                  ) ;

  # After a timeout, go back to main satellite screen.
  print <<EOF;
    <Script>
    parent.loadAfterDelay( "/perl-scripts/rconfigDisplay.cgi", 2000) ;
    </Script>
EOF

}
else
{
  print h2( 'Missing parameters to setPps.cgi' ) ;
}

print end_html() ;


########################################################################
# end of file setPps.cgi
########################################################################
