#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setSleepMode.cgi,v 1.4 2003/06/13 16:48:50 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/setSleepMode.cgi,v $

########################################################################
# setSleepmode.cgi
#
# Script for setting the Sleepmode power saving mode.
# This script is called to finalize the user's selections, typically
# from the perl-scripts/sleepmode.cgi script.
#
# Expected CGI parameters are:
#       Enable   = 'yes' or 'no'            (PowerSave mode enabled)
#       Periodic = 'yes' or 'no'            (failsafe alarm)
#       Hours    = a number from 1 to 24    (failsafe interval)
#       Minutes  = a number from 1 to 60    (failsafe duration)
# 
# These controls are saved in a configuration file -
# /etc/sysconfig/sleepmode, which contains a single line with the four
# CGI fields in the order given above.  For example it might show:
#
#       yes no 24 10
# 
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Sleepmode' ) ;


# for my $p (param())
# {
#   print "$p = ",param($p),br() ;
# }

my $enable = param('Enable') ;
my $periodic = param('Periodic') ;
my $hours = param('Hours') ;
my $minutes = param('Minutes') ;

# Protect against missing parameters.
# Could also check their values here, but there's only so much time
# in the day.
if ( $enable eq ''
  or $periodic eq ''
  or $hours eq ''
  or $minutes eq ''
   )
{
  print 'One or more parameters not properly specified!' ;
  print '<Script>parent.loadAfterDelay("/perl-scripts/sleepMode.cgi", 2000);</Script>' ;
}
else
{
  open( SLEEP, '>/tmp/sleepmode' ) ;
  print SLEEP join( ' ', 
                    $enable,
                    $periodic, 
                    $hours,
                    $minutes,
                  ), 
              "\n" ;
  close SLEEP ;
  system( 'sudo cp /tmp/sleepmode /etc/sysconfig' ) ;

  print h2('New Power Saving Controls Accepted.' ) ;
  print '<Script>parent.loadAfterDelay("/perl-scripts/sessions.cgi", 2000);</Script>' ;
}

print end_html() ;

########################################################################
# end of script setSleepMode.cgi
########################################################################
