#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: startSessions.cgi,v 1.6 2003/12/19 01:46:22 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/gpsadmin/startSessions.cgi,v $

########################################################################
#
# File startSessions.cgi
#
# CGI script for starting/stopping data logging sessions in fireball.
# Called with a parameter of the form:
#
#   ?enable=sessname
# or 
#   ?disable=sessname
#
# Enables or disables the specified session.  
# Displays an acknowledgement page for a short period.
# Switches back to the data logging sessions status page.
# This script is invoked in one of three ways
#
# The configuration data for sessions is contained in
# /etc/syconfig/sessions.
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Start Session' ) ;


########################################################################
# Adjust the enable state of a session if the "enable" or "disable"
# parameters are set
########################################################################
if ( param("enable") or param("disable") ) 
{
  my( $sessname,$ena ) ;
  if (param("enable"))
  {
    $sessname = param("enable") ;
    $ena = '1' ;
    print h2("Session $sessname has been Enabled") ;
  }
  else
  {
    $sessname = param("disable") ;
    $ena = '0' ;
    print h2("Session $sessname has been Disabled") ;
  }

  EnaDisSession( $sessname, $ena ) ;
  
  print <<EOF ;
  <script>
  // Reload the status page after a few seconds.
  parent.loadAfterDelay( '/perl-scripts/sessions.cgi', 2000 ) ;
  </script>
EOF

}
else
{
  print( "Missing parameters.<br />",
         "Need '?enable=sessname' or '?disable=sessname'" 
       ) ; 
}

print end_html() ;

########################################################################
# end of file startSessions.cgi
########################################################################
