#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: http.cgi,v 1.4 2004/03/18 21:58:49 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/http.cgi,v $

########################################################################
# perl-scripts/http.cgi
#
# This script displays the current state of the Http port configuration
# controls.
#
# An "OK" button accepts changes to the form.
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'HTTP Configuration',
               '/httpInfo.html'
             ) ;



my %httpSetup ;

getHttpSetup( \%httpSetup ) ;




#for my $k (keys %httpSetup)
#{
#  print "$k : $httpSetup{$k}<br />" ;
#}

print startform( -name=>'theForm', 
                 -action=>'/perl-scripts/sysadmin/setHttp.cgi'
               ) ;


print b( 'HTTP Standard Port 80' ) ;

my @buttons=radio_group( -name=>'port80',
                         -values=>[ 1, 0 ],
                         -nolabels=>1,
                         -default=> $httpSetup{'httpPort80'}
                       ) ;

print table( {border=>1, width=>'70%'},
        Tr( td( $buttons[0]),
            td( b('Enabled'),
                br(),
                'Accept HTTP requests on Port 80.'
              )
          ),
        Tr( td( $buttons[1]),
            td( b('Disabled'), 
                br(), 
                'Reject HTTP requests on Port 80.'
              )
          )
      ) ;



print br(),
      br(),
      b( 'HTTP Alternate port ' ),
      textfield( 'httpAltPort', 
                 $httpSetup{'httpAltPort'},
                 10, 
                 10
               ) 
      ;

@buttons=radio_group( -name=>'httpAltEnable',
                         -values=>[ 1, 0 ],
                         -nolabels=>1,
                         -default=> $httpSetup{'httpAltEnable'}
                       ) ;

print table( {border=>1, width=>'70%'},
        Tr( td( $buttons[0]),
            td( b('Enabled'),
                br(),
                'Accept HTTP requests on the alternate port.'
              )
          ),
        Tr( td( $buttons[1]),
            td( b('Disabled'), 
                br(), 
                'Reject HTTP requests on the alternate port.'
              )
          )
      ) ;


print br(),
      br(), 
      b( 'HTTPS Standard Port 443' ) ;

@buttons=radio_group( -name=>'port443',
                      -values=>[ 1, 0, ],
                      -nolabels=>1,
                      -default=>$httpSetup{'httpsPort443'}
                    ) ;

print table( {border=>1, width=>'70%'},
        Tr( td( $buttons[0]),
            td( b('Enabled'),
                br(),
                'Accept HTTPS requests on Port 443.'
              )
          ),
        Tr( td( $buttons[1]),
            td( b('Disabled'), 
                br(), 
                'Reject HTTPS requests on Port 443.'
              )
          )
      ) ;

print br(),
      br(),
      b( 'HTTPS Alternate port ' ),
      textfield( 'httpsAltPort', 
                 $httpSetup{'httpsAltPort'},
                 10, 
                 10 
               ) 
      ;

@buttons=radio_group( -name=>'httpsAltEnable',
                         -values=>[ 1, 0 ],
                         -nolabels=>1,
                         -default=> $httpSetup{'httpsAltEnable'}
                       ) ;

print table( {border=>1, width=>'70%'},
        Tr( td( $buttons[0]),
            td( b('Enabled'),
                br(),
                'Accept HTTPS requests on the alternate port.'
              )
          ),
        Tr( td( $buttons[1]),
            td( b('Disabled'), 
                br(), 
                'Reject HTTPS requests on the alternate port.'
              )
          )
      ) ;


print br(), 
      br(),
      button( -name=>"OK", 
              -value=>"OK",
              -onClick=>'okayClicked()'
            ), 
      button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
          'parent.loadDataFrame( "/perl-scripts/internetEthernet.cgi" )'
            ),
      endform() ;

print <<EOF ;
<script>

/**********************************************************************/
function okayClicked()
/**********************************************************************/
/* Called when the OK button is clicked.
 * This triggers submission of the form data.
 *
 * Before submission, the text entry fields are checked for valid
 * numeric values.  Errors will put up an alert and submissions will
 * be canceled.
 */
{
  f = document.theForm ;


  // Verify that at least one of the HTTP or HTTPS ports is enabled.
  // Otherwise further communications would be impossible.
  if ( f.port80[1].checked
    && f.httpAltEnable[1].checked
    && f.port443[1].checked
    && f.httpsAltEnable[1].checked
     )
  {
    alert( "At least one HTTP or HTTPS port must be enabled!" ) ;
    return ;
  }

  if ( parent.isNotAnInteger( f.httpAltPort.value, 
                              'HTTP Alternate Port' ) 
    || parent.isNotAnInteger( f.httpsAltPort.value, 
                              'HTTPS Alternate Port' ) 
     )
    return ;

  ap  = f.httpAltPort.value = parent.strip( f.httpAltPort.value ) ;
  sap = f.httpsAltPort.value = parent.strip( f.httpsAltPort.value ) ;
  if ( ap < 1024 
    || ap > 65535 
    || sap < 1024 
    || sap > 65535 
     )
  {
    alert( "Alternate port numbers must be more than 1023 "
          +"and less than 65536"
         ) ;
    return ;
  }

  if (sap == ap)
  {
    alert( "Alternate port numbers must be different from each other."
         ) ;
    return ;
  }


  // Check all of the text entry fields.
  if (confirm( "Accept New HTTP Configuration?"
               +"\\nWarning: This may require changing the URL that "
               +"you use to access this NetRS." 
               +"\\nWarning: Changing the HTTP configuration will "
               +"restart the NetRS web server which can take "
               +"60 seconds."
             )
     )
    parent.submitForm( f, '' ) ;

} /* end of okayClicked() */

</script>
EOF

print end_html() ;

########################################################################
# End of script http.cgi
########################################################################
