#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: internetEthernet.cgi,v 1.26 2004/05/07 22:34:56 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/internetEthernet.cgi,v $

# This script displays the current state of the Ethernet Port setup.
# Depending on the Mode it shows either:
#    DHCP : Shows Current DHCP status (assigned IP, etc.)
#    Static : Shows the current setup parameters.
# A "MODIFY" button starts the data entry process to select a
# different mode or change the setup parameters.

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'Ethernet Configuration',
               '/internetEthernetInfo.html'
             ) ;


# Read configuration data into a hash for local reference.
my %ethernetSetup ;
getEthernetSetup( \%ethernetSetup ) ;


my $EthMode = $ethernetSetup{ 'ipmode' } ;

my $gateway   = $ethernetSetup{'gateway'} ;
$gateway = $gateway || 'Not Set' ;

my @DnsServers = split( ',', $ethernetSetup{ 'nameServers' } ) ;
if (! @DnsServers)
{
  @DnsServers = ('Not Set') ;
}

my $domain = $ethernetSetup{ 'dnsDomain' } || 'Not Set' ;

my $searchPath = $ethernetSetup{ 'dnsSearch' } || 'Not Set' ;


if ($EthMode eq "static")
{

  print table
        ( {border=>0},
          Tr( td( {colspan=>2},
                  "The Ethernet Port is using a <b>Static IP</b> setup:"
                )
            ),
          Tr(td("&nbsp;")),

          Tr( th( {align=>"right"}, "IP Address:" ), 
              td( $ethernetSetup{'ip'} ) ),

          Tr( th( {align=>"right"}, "MTU:" ), 
              td( $ethernetSetup{ 'mtu' } ) ),

          Tr( th( {align=>"right"}, "Netmask:" ), 
              td( $ethernetSetup{'netmask'} ) ) ,
          
          Tr( th( {align=>"right"}, "Gateway:" ), 
              td( $gateway ) ) ,

          Tr( th( {align=>"right"}, "Name Servers:" ), 
              td( join( '<BR>', @DnsServers ) ) ),

          Tr( th( {align=>"right"}, "Domain:" ), 
              td( join( '<BR>', $domain ) ) ),

          Tr( th( {align=>"right"}, "Search Path:" ), 
              td( join( '<BR>', $searchPath ) ) ),

          Tr(td("&nbsp;")),

          Tr( th( {align=>"right"}, "MAC Address:" ), 
              td( $ethernetSetup{ 'mac' } ) ),

        ) 

}
elsif ($EthMode eq "dhcp")
{
  print table
        ( {border=>0},
          Tr( td( {colspan=>2},
                  "The Ethernet Port is using a <b>DHCP</b> setup."
                )
            ),

          Tr(td("&nbsp;")),

          Tr( td( {colspan=>2},
                  "Currently assigned values are:"
                )
            ),

          Tr( th( {align=>"right"}, "IP Address:" ), 
              td( $ethernetSetup{ 'ip' } ) ),

          Tr( th( {align=>"right"}, "MTU:" ), 
              td( $ethernetSetup{ 'mtu' } ) ),

          Tr( th( {align=>"right"}, "Netmask:" ), 
              td( $ethernetSetup{ 'netmask' } ) ) ,
          
          Tr( th( {align=>"right"}, "Gateway:" ), 
              td( $gateway ) ) ,

          Tr( th( {align=>"right"}, "Name Server:" ), 
              td( join( '<BR>', @DnsServers ) ) ),

          Tr( th( {align=>"right"}, "Domain:" ), 
              td( join( '<BR>', $domain ) ) ),

          Tr( th( {align=>"right"}, "Search Path:" ), 
              td( join( '<BR>', $searchPath ) ) ),

          Tr(td("&nbsp;")),
          Tr( th( {align=>"right"}, "MAC Address:" ), 
              td( $ethernetSetup{ 'mac' } ) ),

        ) 

}
else
{
  print "The Ethernet Port is currently <b>Disabled</b>." ;
}

# Start the form portion of the page.
print startform() ;
print button( -name=>'Modify', 
              -value=>'Modify',
              -onClick=>'parent.loadDataFrame( 
                          "/perl-scripts/sysadmin/ethernetSetup.cgi" )'
            ) ;
print endform() ;


print end_html() ;

########################################################################
# End of script internetEthernet.cgi
########################################################################
