#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: masks.cgi,v 1.8 2003/11/07 23:55:23 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/masks.cgi,v $

########################################################################
# masks.cgi
#
# Display and allow modification of the Positioning and Tracking 
# controls.  Currently this is only two possible controls.
#
#   Elevation Mask
#   PDOP Mask
#
# This page puts up the HTML form that lets the user view and enter
# new values for the two masks.  WHen the user clicks OK, the form
# data is submitted to the script gpsadmin/setMasks.cgi.  The form is
# unrestricted, allowing any user to view the data.  The setMasks.cgi
# script IS restricted, preventing unauthorized users from setting the
# masks.
#
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'Mask Controls',
               '/maskInfo.html'
             ) ;


# Use sysinfo -p elev_mask to get the current setting.
# Response is of the form
#   put elev_mask 12.345
(undef, undef, my $elevMask, undef) 
  = split( ' ',
           qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p elev_mask ) 
         );


# Use sysinfo -p pdop_mask to get the current setting.
# Response is of the form
#   put pdop_mask 7
(undef, undef, my $pdopMask, undef) 
  = split( ' ',
           qx( /usr/bin/sudo /usr/local/fireball/sysinfo -p pdop_mask )
         ) ;


print startform( -name=>'theForm', 
                 -action=>'/perl-scripts/gpsadmin/setMasks.cgi'
               ) ;

print table(

        Tr( 
            td( {align=>"right"}, "Elevation Mask &deg;" ), 
            td( textfield( 'elevMask', $elevMask, 3, 3 ) ) 
          ) ,

        Tr( td( {align=>"right"}, "PDOP Mask" ), 
            td( textfield( 'pdopMask', $pdopMask, 3, 3 ) ) 
          ) ,

          ) ;

print p(),button( -name=>"OK", 
              -value=>"OK",
              -onClick=>"Okay() ;",
            ) ;
print "&nbsp;" ;
print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
            'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" )'
            ) ;

print <<EOF ;
<Script>

/**********************************************************************/
function strip( s )
/**********************************************************************/
/* Strip leading and trailing spaces from the string s.
 * Returns a copy of the string without the spaces.
 */
{
  while ( (s.length > 1)
       && (s.charAt(0) == " ")
        )
  {
    s = s.substring(1,s.length) ;
  }

  while ( (s.length > 1)
       && (s.charAt(s.length-1) == " ")
        )
  {
    s = s.substring(0,s.length-1) ;
  }



  if ( (s.length == 1)
    && (s.charAt(0) == " ")
     )

    s = "" ;
  //alert( "-" + s + "-" ) ;
  return s ;
}

/**********************************************************************/
function isNotAnInteger( s, label )
/**********************************************************************/
{
  bad = false ;
  s = strip(s) ;
  intval = parseInt(s) ;

  if ( isNaN(intval)) bad = true ;

  for (i = 0 ; i < s.length ; ++i)
  {
    c = s.charAt( i ) ;
    if ( ( c < '0' || c > '9') 
      && (c != '+') 
      && (c != '-') 
       ) 
      bad = true ;
  }

  if (bad)
  {
    alert( label + " must be an integer.") ;
    return true ;
  }
  else
    return false ;
} /* end of isNotAnInteger() */




/**********************************************************************/
function Okay()
/**********************************************************************/
/* Invoked when the OK button is pressed.
 * This checks the entry fields for validity and then submits the 
 * entire form with all parameters.
 */
{
  f = document.theForm ;

  //alert( f.elevMask.value + "  " + f.pdopMask.value ) ;

  if ( f.elevMask != null)
  {
     elevMask = strip( f.elevMask.value ) ;

     if (isNotAnInteger( elevMask, "Elevation Mask"))
       return ;

     if ( (elevMask < -10) || (elevMask > 90) )
     {
       alert( "Elevation Mask must be in range -10 to +90." ) ;
       return ;
     }

  }

  if ( f.pdopMask != null)
  {
     pdopMask = strip( f.pdopMask.value ) ;

     if (isNotAnInteger( pdopMask, "pdop Mask"))
       return ;

     if (pdopMask < 0 || pdopMask>99)
     {
       alert( "Pdop Mask range is 0 to 99." ) ;
       return ;
     }
  }

  parent.submitForm( f, '' ) ;

} /* end of Okay() */


</Script>
EOF


print end_form() ;

print end_html() ;

########################################################################
# end of file masks.cgi
########################################################################
