#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: multipath.cgi,v 1.6 2003/07/16 20:33:57 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/multipath.cgi,v $

########################################################################
# multipath.cgi
#
# Provides a method to control the multipath function of Stinger.  This
# function has the trademark name "Everest"(tm) which is used in the
# name of the command to control the feature:
#
#   put everest [off|on]
#
# Likewise "get multipath" on the info channel will provide that
# value back to you.
#
# This script is called to put up the HTML form for controlling the
# multipath function.  No CGI parameters are used.  When the user
# clicks on OK, the script gpsadmin/setMultipath.cgi is called with
# the desired setting to activate the change.  Only the
# setMultipath.cgi script has access restrictions.  This script
# (multipath.cgi) is not restricted and anyone can view the form it
# creates.
#
########################################################################


use strict ;
use CGI qw/:standard/;

use Fireball ;

titleWithHelp( 'Multipath Control',
                         '/multipathInfo.html'
                       ) ;


# Obtain current setting from gpsinfo system, using sysinfo.
# Response will be of the forms:
#  put everest on 
#  put everest off
$_ = qx( /usr/local/fireball/sysinfo -p everest ) ;
chomp ;

#print $_, br() ;

my (undef, undef, $MPstate) = split( " ", $_ ) ;

print startform( -name=>'theForm', 
                 -action=>'/perl-scripts/gpsadmin/setMultipath.cgi'
               ) ;


my @Control = radio_group( -name=>'Multipath', 
                           -value=>[ 'on', 'off' ],
                           -nolabels=>1,
                           -default=> $MPstate
                         ) ;

print table( {border=>'1'},
             Tr(
                td( {width=>'30', align=>'center'}, $Control[0] ),
                td( b('Enabled'),br(),
                    'Everest&reg; Multipath Reduction will be used to '
                    .'reduce the effects of indirect (bounced) signals '
                    .'on code phase measurements.'
                  )
               ),
             Tr(
                td( {align=>'center'}, $Control[1] ),
                td( b('Disabled'),
                    br(),
                    'Everest&reg; Multipath Reduction will NOT be used.'
                  )
               )
           ) ;

print br(),hr() ;


# No action was done. In other words this invocation is just 
# displaying the form for accepting new data.  Put up the buttons.
print button( -name=>'OK', 
              -value=>'OK',
              -onClick=>'parent.submitForm( document.theForm, "" )'
            ) ;
print '&nbsp;' ;
print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
           'parent.loadDataFrame( "/perl-scripts/rstatusIdentity.cgi" )'
            ) ;

print endform() ;

 
print end_html() ;

# end of file multipath.cgi
