#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: ntp.cgi,v 1.11 2004/05/19 21:33:04 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/ntp.cgi,v $

########################################################################
# ntp.cgi
#
# Script to allow control of the NTP subsystem.  Called without
# parameters to put up an HTML form showing the current configuration
# of the NTP system.  When the user clicks on OK, the parameters
# are fed to sysadmin/setNtp.cgi which updates the current
# configuration.
#       
########################################################################


use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'NTP Client Configuration', '/ntpInfo.html') ;


my @servers = () ;

# If there are no CGI parameters coming into this script then it
# is an "original" invocation, so we determine the default values for
# all of the GUI widgets by reading the configuration files.
# script.
# But if any parameters came in, then this is a re-invocation (as due
# to an error on submission) and the default values are those that
# were passed to setNtp.cgi, and re-posted here.
if (!param() )
{
  # Read the current setup and make that the defaults for all widgets.

  # Default the ntpDisable checkbox to checked.  Overridden if any
  # time servers are found in the config files.
  param( 'ntpDisable', '1' ) ;

  @servers = getNtpServers() ;

  # If any servers were found, then we uncheck the disable box.
  param( 'ntpDisable', '0' ) if (@servers) ;
}


if (param('msg'))
{
  print h3( param( 'msg' ) ) ;
}

print startform( -name=>'theForm',
                 -action=>'/perl-scripts/sysadmin/setNtp.cgi'
               ) ;

print b( 'External Time Servers:' ) ;
print "<Table>" ;

for (my $i = 0 ; $i < 3 ; ++$i)
{
  print Tr( td( {width=>"40"}, "" ), 
            td( textfield( -name=>'server'.$i, 
                           -default=>$servers[$i], 
                           -size=>30, 
                           -maxlength=>100,
                           -onChange=>'enableNTP();', 
                         ) 
              ) 
          ) ;
}

  print Tr( td( {align=>'right'}, 
                checkbox( -name=>'ntpDisable',
                          -value=>'1',
                          -label=>'',
                          -onclick=>'disableNTP();'
                        ) 
              ),
            td( 'Disable using NTP time servers.' ) 
          ) ;

print "</Table>" ;

# Emit some javascript programs to handle the relationship between the
# textfield boxes and the Disable checkbox.
print <<EOF ;
<script>

function disableNTP()
/* Called when the ntpDisable checkbox is clicked.  If the box is
 * checked, then we need to clear out the text fields showing the
 * NTP time servers.
 */
{
  if (document.theForm.ntpDisable.checked)
  {
    document.theForm.server2.value = '' ;
    document.theForm.server1.value = '' ;
    document.theForm.server0.value = '' ;
  }
} // end of disableNTP()

function enableNTP()
/* Called when the server text fields are modified.  This is the 
 * inverse operation of disableNTP().  The idea is that if you enter
 * an NTP time server, the Disable box will clear.  Note that this
 * will only occur if the text fields are modified and the focus is
 * then shifted to another form element.
 */
{
  document.theForm.ntpDisable.checked = false ;
} // end of disableNTP()


</script>
EOF


print p(),button( -name=>'OK', 
              -value=>'OK',
              -onClick=>'parent.submitForm( document.theForm, "" )'
            ) ;
print "&nbsp;" ;
print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>'parent.loadDataFrame( 
                                 "/perl-scripts/internetEthernet.cgi" )'
            ) ;

print endform() ;

print end_html() ;

########################################################################
# End of file ntp.cgi
########################################################################
