#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: reset.cgi,v 1.16 2004/08/19 22:54:42 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/reset.cgi,v $

########################################################################
# reset.cgi
#
# Script that allows user to Reset or restart the system in several
# ways.  This script is called without parameters and puts up a form
# with some buttons.  When these are selected, javascript functions are
# called to ask for confirmation from the user.  If successful, then
# the gpsadmin-secured script doReset.cgi is called with to implement
# the requested form of reset.
# 
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;

titleWithHelp( 'System Reset',
               '/resetInfo.html'
             ) ;


print start_form( -name=>'theForm' ) ;

print table( 
             # First button is a plain "Restart".
             # Calls function RestartButton() function when clicked.
             Tr( td( {align=>'right'},
                     button( -name=>'Restart', 
                             -value=>'Restart',
                             -onClick=>'RestartButton() ;',
                           )
                   ),

                 td( "Restart this NetRS" )
               ),
             Tr( td( "&nbsp;" ) ) ,

             # Next button is a "Clear Almanac".
             # Calls function RestartButton() function when clicked.
             Tr( td( {align=>'right'},
                     button( -name=>'Clear', 
                             -value=>'Clear GPS Data',
                             -onClick=>'ClearButton() ;',
                           )
                   ),

                 td( "Clear the GPS satellite Ephemeris and Almanac"
                    ." data,<br />and restart this NetRS." 
                   ),
               ),
             Tr( td( "&nbsp;" ) ) ,
             Tr( td( {align=>'right'},
                     button( -name=>'Cancel', 
                             -value=>'Cancel',
                             -onClick=>
              'parent.loadDataFrame("/perl-scripts/rconfigDisplay.cgi")'
                           )
                   ),
               ),
           ) ;


print end_form() ;

# Embed the javascript functions called by the buttons.
print <<EOF;
<Script>

/**********************************************************************/
function ClearButton()
/**********************************************************************/
/* Called when the Clear button is pressed.
 * Asks for confirmation and then submits the request to the NetRS.
 */
{
  if ( confirm( "Reseting Ephemeris & Almanac.\\n"
               +"This will restart your NetRS.\\n"
               +"Are you sure?" ) 
     )
  {
    parent.loadDataFrame('/perl-scripts/gpsadmin/doReset.cgi?clear=1') ;
  }
} /* end of ClearButton() */




/**********************************************************************/
function RestartButton()
/**********************************************************************/
/* Called when the Restart button is pressed.
 * Asks for confirmation and then submits the request to the NetRS.
 */
{
  if (confirm( "This will restart your NetRS.\\n"
              +"Are you sure?" )
     )
  {
    parent.loadDataFrame(
                      '/perl-scripts/gpsadmin/doReset.cgi?restart=1' ) ;
  }
} /* end of DefaultsButton() */


</Script>
EOF

print end_html() ;

########################################################################
# end of script reset.cgi
########################################################################
