#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: configDelete.cgi,v 1.5 2003/12/19 01:46:22 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/configDelete.cgi,v $

########################################################################
# configDelete.cgi
# Script for deleting Fireball Configuration Files
# 
# Via the Web-GUI interface we can create, delete, download, upload and 
# apply "configuration files".  These are collections of Fireball
# control settings.  The files reside in /etc/sysconfig/configFiles.
#
# This script handles the sub-task of deleting a specific configFile.
# It is passed the file to delete in a CGI parameter.
#
# delete=fname
#       A request to delete the configfile named fname.
#
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Config Delete' ) ;


#if (param())
#{
#  print "Parameters Received:<br />" ;
#  foreach my $p (param()) 
#  {
#    print "$p=",param($p),br() ;
#  }
#}

my $result ;

my $filename = param('delete') ;

if ( defined ($filename)
 and -f "/etc/sysconfig/configFiles/$filename" 
   )
{
  $result = "Configuration file \"$filename\" has been deleted." ;
  system( "sudo /bin/rm -f '/etc/sysconfig/configFiles/$filename'" ) ;
}
else
{
  $result = "No such configuration file \"$filename\"." ;
}

print h3( $result ) ;

my $returnURL = '/perl-scripts/configFiles.cgi'
              . '?message='.CGI::escape( $result )
              ;

print <<EOF ;
<Script>
  parent.loadAfterDelay( "$returnURL", 1000) ;
</Script>
EOF


print end_html() ;

EXIT:
########################################################################
# end of file configFiles.cgi
########################################################################
