#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: configDownload.cgi,v 1.2 2004/04/08 22:56:12 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/configDownload.cgi,v $

########################################################################
# configDownload.cgi
# Script for downloading Fireball Configuration Files
# 
# Via the Web-GUI interface we can create, delete, download, upload and 
# apply "configuration files".  These are collections of Fireball
# control settings.  The files reside in /etc/sysconfig/configFiles.
#
# This script handles downloading a previously created configfile.
# It is activated via a pseudo-URL of the form:
#
#   http://netRSxxx/configDownload/configFileName
#
# Such a URL is redirected by our web server (due to a ScriptAliasMatch
# configuration directive in httpd.conf) to call this script.  The
# full URL is available via the environment variable SCRIPT_NAME,
# which will look like:
#   
#   /configDownload/configFileName
#
# In response, this script will extract the configFileName and 
# download that file from /etc/sysconfig/configFiles.  We use 
# sendBinaryFile() to send the file with a non-existent "Content-Type"
# of "force_download".  That should pop up window on the user's browser
# asking where to store the data.  It is up to the browser to determine
# the suggested file name from the URL.  In general it should match
# configFileName.
########################################################################

use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;


# Extract the name of the requested file from the environment
# variable.  We could also use REQUEST_URI, but that variable has 
# HTTP escaped characters still encoded.  The SCRIPT_NAME value should
# look something like:
#
#   /configDownload/configFileName
#
# We'll drop the /configDownload/ portion and replace that with
# '/etc/sysconfig/configFiles/'.

my $path = $ENV{'SCRIPT_NAME'} ;
$path =~ s|^/configDownload/|/etc/sysconfig/configFiles/| ;
  
# Send back the requested file.  Do this with a technique that
# requests the client system to download and save the file.
sendBinaryFile( $path ) ;

########################################################################
# end of file configDownload.cgi
########################################################################
