#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: configSave.cgi,v 1.13 2004/06/08 21:31:36 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/configSave.cgi,v $

########################################################################
# configSave.cgi
# Script for Creating new Fireball Configuration Files
# 
# Via the Web-GUI interface we can create, delete, download, upload and 
# apply "configuration files".  These are collections of Fireball
# control settings.  The files reside in /etc/sysconfig/configFiles.
#
# This script implements the actual creation of a configuration file,
# based on CGI parameters passed in from perl-scripts/configCreate.cgi.
# Currently only one is used, but others will definitely be added soon
# to control the exact contents of the configuration file.
#
# save=fname
#       Save the current settings in the named configuration file.
# 
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Config Save' ) ;


my $result ;

# We'll build up a list of functions reqested in this configuration
# file from the categories that were checked on the GUI page.
my @functions = () ;

#print "Parameters Received:<br />" ;
foreach my $p (param()) 
{
  #print "$p=",param($p),br() ;

  next if $p eq 'fname' ; # Skip the filename parameter.

  push( @functions, $p ) ;
}

if (my $fname=param('fname'))
{
  # The user requested saving current configuration in a configfile.
  # $fname contains the name to give it.

  $fname =~ s/^ +// ; # Drop leading spaces.
  $fname =~ s/ +$// ; # Drop trailing spaces.

  # Replace any characters we don't want in file names with underscores.
  $fname =~ tr { /} {_} ; # Spaces and slashes to underscores.

  $result = "Current Configuration saved in \"$fname\"." ;

  MakeConfigFile( $fname, @functions ) ;
}
else
{
  $result = 'No configfile Name specified' ;
}


print h3( $result ),br() ;

my $returnURL = '/perl-scripts/configFiles.cgi'
              . '?message='.CGI::escape( $result )
              ;

print <<EOF ;
<Script>
  parent.loadAfterDelay( "$returnURL", 1000) ;
</Script>
EOF


print end_html() ;

########################################################################
# end of file configSave.cgi
########################################################################
