#!/usr/bin/perl -w
# Copyright (c) 2005 Trimble Navigation Limited
# $Id: diskTests.cgi,v 1.5 2005/03/19 02:00:21 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/diskTests.cgi,v $

# disktests.cgi
# Script for displaying the disk testing page.
# Allows triggering of disk test routines and the display
# of stored and current results.

use strict ;
use CGI qw/:standard/;
use Fireball ;



titleWithHelp( 'Disk Tests',
               '' # No Help
             ) ;

my $updatePartition = param( "update" ) ;

if ($updatePartition)
{
  print "Saved results updated for $updatePartition" ;
  system( "/usr/bin/sudo /bin/mount -oremount,rw /etc/sysinfo" ) ;
  system( "/usr/bin/sudo /bin/cp -p "
         ."/var/tmp/badblocks.$updatePartition /etc/sysinfo"
        ) ;
  system( "/usr/bin/sudo /bin/mount -oremount,ro /etc/sysinfo" ) ;
}

my $clearPartition = param( "clear" ) ;

if ($clearPartition)
{
  print "Results cleared for $clearPartition" ;
  system( "/usr/bin/sudo /bin/rm /var/tmp/badblocks.$clearPartition" );
}

my $testPartition = param( "test" ) ;

my $checkBadBlocksRunning = (-e "/var/run/checkBadBlocks.pid") ;

if ($testPartition && ! $checkBadBlocksRunning)
{
  system( "/usr/bin/sudo /usr/local/fireball/checkBadBlocks "
          .$testPartition
          ." &"
        ) ;
  sleep 1 ;
}

$checkBadBlocksRunning = (-e "/var/run/checkBadBlocks.pid") ;
if ($checkBadBlocksRunning)
{
  $testPartition = 
                 (split " ", qx( cat /var/run/checkBadBlocks.pid ))[1] ;
  print '<font color="red">',
        "<blink>Testing partition</blink> $testPartition",
        "</font>"
        ;
  print <<EOF ;
    <script>
    parent.loadAfterDelay( '/perl-scripts/sysadmin/diskTests.cgi',
                           15000 
                         ) ;
    </script>
EOF

}

print startform( -name=>"theForm" ) ;
print hr() ;
for my $partition ('part1', 'part2', 'part3', 'part4')
{
  my $latestDate = "Not Tested" ;
  my $latestBadBlocks = "Not Tested" ;
  my $f = "/var/tmp/badblocks.$partition" ;
  if ( -e $f )
  {
    my (undef, undef,undef, undef, undef, undef, undef,
        $size, undef, $mtime, undef ) = lstat $f ;

    # Convert modification time to date and time of day.
    my (undef,$min,$hour,$day,$month,$year) = gmtime($mtime) ;
    $month= $monthStrings[$month] ;

    # Format nicely with a fixed-length field.  Put leading zeroes
    # on all # variable length numbers.  Should look like: 
    # "11-JUL-2002 19:32"
    $latestDate = sprintf( "%02d-%s-%04d&nbsp;%02d:%02d", 
                          $day,   
                          $month, 
                          $year+1900,
                          $hour,  
                          $min
                        ) ;
                        
    if ($size > 0)
    {
      $latestBadBlocks = qx(cat $f) ;
      $latestBadBlocks = join( "<br />",
                              split( " " , $latestBadBlocks )
                            ) ;
    }
    else
    {
       $latestBadBlocks = "No Bad Blocks" ;
    }
  }

  my $savedDate = "Not Saved" ;
  my $savedBadBlocks = "" ;
  $f = "/etc/sysinfo/badblocks.$partition" ;
  if ( -e $f )
  {
    my (undef, undef,undef, undef, undef, undef, undef,
        $size, undef, $mtime, undef ) = lstat $f ;

    # Convert modification time to date and time of day.
    my (undef,$min,$hour,$day,$month,$year) = gmtime($mtime) ;
    $month= $monthStrings[$month] ;

    # Format nicely with a fixed-length field.  Put leading zeroes
    # on all # variable length numbers.  Should look like: 
    # "11-JUL-2002 19:32"
    $savedDate = sprintf( "%02d-%s-%04d&nbsp;%02d:%02d", 
                          $day,   
                          $month, 
                          $year+1900,
                          $hour,  
                          $min
                        ) ;
                        
    if ($size > 0)
    {
      $savedBadBlocks = qx(cat $f) ;
      $savedBadBlocks = join( "<br />",
                              split( " " , $savedBadBlocks )
                            ) ;
    }
    else
    {
       $savedBadBlocks = "No Bad Blocks" ;
    }
  }


  my $markedBadBlocks = "&nbsp;" ;

  if ($partition ne "part1")
  {
    open( DUMP, 
          "/usr/bin/sudo /sbin/dumpe2fs "
         ."-b /dev/discs/disc0/$partition 2>/dev/null |"
        ) ;
    #$markedBadBlocks = <DUMP> ; # drop first line = dumpe2fs version
    $markedBadBlocks = join( "<br />", <DUMP> ) ;

    close( DUMP ) ;

    if (length($markedBadBlocks) == 0)
    {
      $markedBadBlocks = "None" ;
    }
  }
  else
  {
    $markedBadBlocks = "N/A" ;
  }


  print b("/dev/discs/disc0/$partition : ") ;
  if ($partition eq 'part1')
  {
    print "Boot/Kernel partition" ;
  }
  elsif ($partition eq 'part2')
  {
    print "Root File System" ;
  }
  elsif ($partition eq 'part3')
  {
    print "/var File System (Temporary files)" ;
  }
  elsif ($partition eq 'part4')
  {
    print "/var/gps File System (Data Logging, etc.)" ;
  }

  print "<table border=1>" ;
  print Tr( th( [ "Latest Test", "Saved Test", "Marked Bad" ] ) ) ;

  print Tr( 
            td( {align=>'center'}, $latestDate ),
            td( {align=>'center'}, $savedDate ),
            td( "&nbsp;" )
          ) ;
  
  print Tr( 
            td( {align=>'center'}, $latestBadBlocks ),
            td( {align=>'center'}, $savedBadBlocks ),
            td( {align=>'center'}, $markedBadBlocks )
          ) ;


  if ( ! $checkBadBlocksRunning )
  {
    print Tr( 
              td( {align=>'center'},
                  button( -name=>"Test",
                          -value=>"Test",
                          -onClick=>"DtTest( '$partition' )"
                        )
                 .( ($latestDate ne "Not Tested")
                    ? button( -name=>"Clear",
                              -value=>"Clear",
                              -onClick=>"DtClear( '$partition' )"
                            )
                    : ""
                  )
                ),
              td( {align=>'center'},
                  ($latestDate ne "Not Tested")
                  ? button( -name=>"Update",
                            -value=>"Update",
                            -onClick=>"DtUpdate( '$partition' )"
                          )
                  : ""
                )
            ) ;
  }

  print "</table>", hr() ;
}


print <<EOF ;
<script>

/**********************************************************************/
function DtTest( partition )
/**********************************************************************/
/* Javascript function called when the user presses a button to
 * trigger a CF partition badblocks test.
 * After a confirmation warning, the CGI request is submitted to
 * the server, including something like "?test=part4 as a CGI parameter.
 */
{
  if ( confirm( "Perform Block Test on " + partition + "?"
               +"\\nThis can take several minutes and will heavily"
               +" load your system." 
              ) 
     )
  {
    parent.loadDataFrame( "/perl-scripts/sysadmin/diskTests.cgi?test="
                        + partition
                        ) ;
  }
} /* end of DtTest() */


/**********************************************************************/
function DtUpdate( partition )
/**********************************************************************/
/* Javascript function called when the user presses a button to
 * trigger the saving of the results from a CF partition badblocks test.
 * The CGI request is formatted and sent to the server, including
 * something like "?update=part4 as a CGI parameter.
 */
{
  //alert( "Saving " + partition ) ;
  parent.loadDataFrame( "/perl-scripts/sysadmin/diskTests.cgi?update="
                      + partition
                      ) ;
} /* end of DtUpdate() */

/**********************************************************************/
function DtClear( partition )
/**********************************************************************/
/* Javascript function called when the user presses a button to
 * trigger Clearing the results from a CF partition badblocks test.
 * The CGI request is formatted and sent to the server, including
 * something like "?clear=part4 as a CGI parameter.
 */
{
  //alert( "Clearing " + partition ) ;
  parent.loadDataFrame( "/perl-scripts/sysadmin/diskTests.cgi?clear="
                      + partition
                      ) ;
} /* end of DtUpdate() */

</script>

EOF

print endform() ;
print end_html() ;

########################################################################
# end of file disktests.cgi
########################################################################
