#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: firmwareVerify.cgi,v 1.4 2003/12/19 01:46:22 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/firmwareVerify.cgi,v $


########################################################################
# firmwareVerify.cgi
#
# Script to verify an RPM file after a firmware upload.
# This is called after a firmware file upload (see firmwareUpload.cgi).
# Passed a parameter 
#
#       ?fname=xyz.rpm
#
# that specifies the name of a file in /var/gps/incoming that is to be
# verified.  The global function Fireball::RpmVerify is called to 
# do the actual verification.  RpmVerify also reclaims /var space as
# needed.
#
# If the file verifies properly, a message is displayed and the GUI
# is switched to the firmware status page.  If not, then a warning
# dialog appears, error messsages are displayed, and a "Done" button 
# is used on the page to indicate to the user that they have to dismiss
# this page.
########################################################################

use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

titleWithHelp( 'Upload Firmware File',
               '/firmwareUpload.html'
             ) ;
           
my $errorMessage = '' ;
my $testResults  = '' ;

my $fname = param('fname') ;
print b( "Verifying file $fname<br />" ) ;

########################################################################
# Define the location where the firmware files are stored, switch
# the current directory to there and set the CGI scripts to upload
# data directly into that directory.
my $firmwareDir = '/var/gps/incoming' ;
chdir $firmwareDir ;

if (! -r $fname)
{
  $errorMessage = "Can't find file $fname." ;
  goto ERROR ;
}

#print qx( ll $fname ),p() ;

# Verify the file.  Second parameter indicates "verbose", which means
# the routine will emit information to stdout about what it is doing.
$testResults  = RpmVerify( $fname, 1 ) ;

if ($testResults eq '')
{
  print b('Verified successfully.') ;

  # After a timeout, go back to main Sessions screen.
  print <<EOF;
      <br />Switching to Firmware Status Page
      <Script>
      parent.loadAfterDelay( "firmware.cgi", 3000) ;
      </Script>
EOF

  # Done with page.  Skip the rest of this perl script.  We could
  # use "exit" but Modperl doesn't like that.  So just goto the end.
  goto EXIT ;
}
else
{
  $errorMessage = "There is a problem with file '$fname'" ;
}


########################################################################
# If an error was detected during CGI processing, we trigger a
# javascript alert box and put up a similar warning on the page.
########################################################################
ERROR:
if ($errorMessage)
{
  print <<EOF ;
    <Script>
    alert( "$errorMessage" ) ;
    </Script>
EOF

  print "<br /><b>$errorMessage</b>" ;
  if ($testResults)
  {
    print "<br />Test results:<pre>$testResults</pre>" ;
  }

  print startform( -name=>"theForm" ) ;
  print button( -name=>'Done', 
                -value=>'Done',
                -onClick=> 
                  'parent.loadDataFrame( "/perl-scripts/firmware.cgi" )'
              ) ;

  print endform() ;

}

EXIT:
print end_html() ;
########################################################################
# end of file firmwareVerify.cgi
########################################################################
