#!/usr/bin/perl -w
# Copyright (c) 2004 Trimble Navigation Limited
# $Id: setAdvertise.cgi,v 1.3 2004/05/13 22:52:20 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/setAdvertise.cgi,v $

########################################################################
# setAdvertise.cgi
#
# Script to enable activating new configuration of the port Advertising
# feature.
# Called by /perl-scripts/advertise.cgi, feeding in CGI parameters 
# of the form:
#   ?
#
# The parameters are parsed, checked and saved away in the
# sysconfig/advertise  configuration file.
#
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;


########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Port Advertising' ) ;


#print( "<pre>Parameters Received<BR>" ) ;
#foreach my $p (param())
#{
#    print  "$p=", param($p), "\n" ;
#}
#print "</pre>" ;

# A Hash that will be filled with data from the configuration file.
my %advertiseControls ;

# Read from the configuration file 
# Temporarily use faked data.
$advertiseControls{'enable'} = param('enable') ;
$advertiseControls{'interval'} = param('interval') ;

# Create two elements in the hash that are references to anonymous
# arrays, which start out empty.
$advertiseControls{'ports'} = [] ;
$advertiseControls{'IPs'} = [] ;


# Count how many targets are defined by looking for 'IP'N
# with N=0,1,2,3,4.  
# For each of these that is found, push the IP and the Port values
# onto the arrays in the big hash.
my $targetCount = 0 ;
while ( defined( param( 'IP'.$targetCount ) ) )
{
  push( @{$advertiseControls{'IPs'}}, param( 'IP'.$targetCount ) ) ;
  push( @{$advertiseControls{'ports'}}, param( 'port'.$targetCount ) ) ;
  ++$targetCount ;
}

# Encode the new configuration setup into the configuration file,
# and activate those settings.
saveAdvertiseControls( \%advertiseControls ) ;


print h2( 'New Port Advertising Controls Accepted.' ) ;
print <<EOF ;
<Script> 
parent.loadAfterDelay( "portSummary.cgi", 2000) ;
</Script>
EOF

# For debugging, display the new config file contents.
#print "<pre>" ;
#print "\n\n\n" ;
#print qx( cat /etc/sysconfig/advertise ) ;
#print "</pre>" ;


print end_html() ;

########################################################################
# End of file setAdvertise.cgi
########################################################################
