#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setClientAuth.cgi,v 1.2 2004/04/09 21:46:07 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/setClientAuth.cgi,v $

########################################################################
# setClientAuth.cgi
#
# Script to accept a new client authentication password.
# Called by /perl-scripts/clientAuth.cgi, feeding in CGI parameters of
# the form:
#
#   ?key1=abc123X&key2=abc123X
#
# The two Key parameters are compared to each other, to be sure that
# they match.  If they don't, an error is posted and the original form
# is reloaded.
# 
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Client Authentication Key' ) ;
print h2( "Client Authentication Key" ) ;

my $errorMessage ;


#print( "<pre>Parameters Received<BR>" ) ;
#foreach my $p (param())
#{
#    print  "$p=", param($p), "\n" ;
#}
#print "</pre>" ;



my $key1 = param( 'key1' ) ;
my $key2 = param( 'key2' ) ;

# Trim leading and trailing spaces.
$key1 =~ s/^\s+// ;
$key2 =~ s/^\s+// ;
$key1 =~ s/\s+$// ;
$key2 =~ s/\s+$// ;

if ($key1 !~ /\S{7}/)
{
  $errorMessage = "Key must be seven non-space characters" ;
  goto ERROR ;
}

if ($key1 ne $key2)
{
  $errorMessage = "Second Key entry must match first." ;
  goto ERROR ;
}


my $code = qx( /usr/local/fireball/makeKey $key1 ) ;
chomp $code ;

print h2( 'New Client Authentication key Accepted.' ) ;

# Read in the data from the configuration files and put in a Hash.
my %allPortData ;
getPortSetup( \%allPortData ) ;


$allPortData{'AuthKey'} = $code ;


# Regenerate gpssd.config and inform the streaming daemon
# to examine the configuration for changes.
saveGpssdConfig( \%allPortData ) ;



# After a timeout, switch to another display.
print <<EOF ;
<Script>
  parent.loadAfterDelay( "/perl-scripts/portSummary.cgi", 2000) ;
</Script>

EOF
goto EXIT ;


ERROR:
# An error was found during CGI parameter processing.  We need to
# display the error message, and then switch back to the HTML form
# page that got us here.  In order to preserve what the user had
# already entered, we need to post all of the CGI parameters back to
# the original script.

print h3( $errorMessage ) ;

print <<EOF ;
<Script>
  alert( "$errorMessage" ) ;
  parent.loadAfterDelay( "/perl-scripts/clientAuth.cgi", 1000) ;
</Script>
EOF


EXIT:
print end_html() ;

########################################################################
# End of file setClientAuth.cgi
########################################################################
