#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: setHttp.cgi,v 1.4 2004/03/18 00:18:10 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/setHttp.cgi,v $

########################################################################
# setHttp.cgi
#
# Script to enable activating new configuration of the HTTP server.
# Called by /perl-scripts/http.cgi, feeding in CGI parameters of the
# form:
#   ?
#
# The parameters are parsed, checked and saved away in the HTTP 
# configuration files.  And then the HTTP daemon is killed.  It is
# supposed to be automatically restarted by the frontpanel_task after a
# short time.
#
# If bad parameters are detected, then a warning is put up and the
# perl-scripts/http.cgi script is called, with the same parameters, and
# a 'msg=' parameter so that the user can fix the errors.
#
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;



########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set HTTP' ) ;

my $errorMessage ;


#print( "<pre>Parameters Received<BR>" ) ;
#foreach my $p (param())
#{
#    print  "$p=", param($p), "\n" ;
#}
#print "</pre>" ;


my %httpSetup ;

$httpSetup{'httpPort80'} = param( 'port80' ) ;
$httpSetup{'httpsPort443'} = param( 'port443' ) ; 

$httpSetup{'httpAltPort'} = param( 'httpAltPort' ) ; 
$httpSetup{'httpAltEnable'} = param( 'httpAltEnable' ) ; 

$httpSetup{'httpsAltPort'} = param( 'httpsAltPort' ) ; 
$httpSetup{'httpsAltEnable'} = param( 'httpsAltEnable' ) ; 




# Verify the parameters are okay...


print h2( 'New HTTP setup accepted.' ),
      h2( 'Restarting HTTP Web Server.' ) ;
print <<EOF ;
Communication to this NetRS will be interrupted for approximately 
60 seconds.  After 60 seconds, this interface should automatically 
restart.
<br />
<br />
Configuration changes may require changing the URL that you are using
to access these web pages.
EOF



# After a timeout, switch to another display.
print <<EOF ;
<script>
   setTimeout( \'parent.document.location = "../NetRS.cgi"\',
               60000
             ) ;
</script>

EOF

saveHttpSetup( \%httpSetup ) ;

goto EXIT ;


ERROR:
# An error was found during CGI parameter processing.  We need to
# display the error message, and then switch back to the HTML form
# page that got us here.  In order to preserve what the user had
# already entered, we need to post all of the CGI parameters back to
# the original script.

print h3( $errorMessage ) ;

my $returnURL = '/perl-scripts/ntp.cgi'
              . '?server0='.CGI::escape( param('server0') )
              . '&server1='.CGI::escape( param('server1') )
              . '&server2='.CGI::escape( param('server2') )
              ;

if ( defined( param('ntpDisable') ) )
{
  $returnURL .= '&ntpDisable='.CGI::escape( param('ntpDisable') ) ;
}
$returnURL .= '&msg='.CGI::escape( $errorMessage ) ;

print <<EOF ;
<Script>
  parent.loadAfterDelay( "$returnURL", 4000) ;
</Script>
EOF


EXIT:
print end_html() ;

########################################################################
# End of file setHttp.cgi
########################################################################
