#!/usr/bin/perl -w
# Copyright (c) 2004 Trimble Navigation Limited
# $Id: setIptables.cgi,v 1.4 2004/03/19 00:28:30 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/setIptables.cgi,v $

########################################################################
# setIptables.cgi
#
# Script to enable activating new configuration of the Iptables
# packet filtering system.
# Called by /perl-scripts/iptables.cgi, feeding in CGI parameters 
# of the form:
#   ?
#
# The parameters are parsed, checked and saved away in the iptables.conf
# configuration file.  ....
#
# If bad parameters are detected, then a warning is put up and the
# perl-scripts/iptables.cgi script is called, with the same parameters,
# and a 'msg=' parameter so that the user can fix the errors.
#
########################################################################


use strict ;
use CGI qw/:standard/;

use lib '..' ;
use Fireball ;

########################################################################
# Begin formatting the return document.
########################################################################
startPage( 'Set Ip Filters' ) ;


#print( "<pre>Parameters Received<BR>" ) ;
#foreach my $p (param())
#{
#    print  "$p=", param($p), "\n" ;
#}
#print "</pre>" ;


# Parse the CGI parameters into an iptablesSetup hash.
my %iptablesSetup ;

$iptablesSetup{'enable'} = param( 'filterEnable' ) ;

# Encode the address range elements.  These will come in
# matched sets of the form: baseField2 & bitsField2.  There
# can be an arbitary number of these starting with index 0.
# We'll keep processing these until we run out of them.
# And we'll encode the number of ranges found.
my @rangeBases ;
my @rangeBits ;
my $rangeCount = 0 ;
while ( defined( param( 'baseField'.$rangeCount ) ) )
{
  $rangeBases[ $rangeCount ] = param( 'baseField'.$rangeCount ) ;
  $rangeBits [ $rangeCount ] = param( 'bitsField'.$rangeCount ) ;
  ++$rangeCount ;
}

$iptablesSetup{'rangeCount'} = $rangeCount ;
$iptablesSetup{'rangeBases'} = \@rangeBases ;
$iptablesSetup{'rangeBits' } = \@rangeBits ;


# Encode the new configuration setup into the configuration file,
# and activate those settings.
saveIptablesSetup( \%iptablesSetup ) ;



print h2( 'New IP Filtering Controls Accepted.' ) ;

# After a timeout, switch to another display.
print <<EOF ;
<script>
   setTimeout( \'parent.document.location = "../NetRS.cgi"\',
               5000
             ) ;
</script>

EOF


print end_html() ;

########################################################################
# End of file setIptables.cgi
########################################################################
