#!/usr/bin/perl -w
# Copyright (c) 2002 Trimble Navigation Limited
# $Id: stingerTest.cgi,v 1.3 2007/02/12 23:49:32 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysadmin/stingerTest.cgi,v $

########################################################################
# StingerTest.cgi
#
# Allows arbitrary commands to be fed to the Stinger Control Interface,
# and displays the results returned by Stinger.
#
# Features a popup menu of known commands, and a text entry field to
# allow typing arbitrary modifications or parameters.
########################################################################

use strict ;
use CGI qw/:standard/;
use IO::Socket;
use Fireball ;

titleWithHelp( 'Stinger Commands',
                         '' # No Help
                       ) ;

my $command = '' ;
#my $restart = '' ;

if (param())
{
  #print( "Parameters Received<BR>" ) ;
  #foreach my $p (param())
  #{
  #    print  "$p=", param($p), " " ;
  #}

  $command = param('Command') ;
  #$restart = param('Restart') ;
}

print startform( -name=>"theForm" ) ;
print textfield( 'Command', 'get pos_info', 80, 80 ) ;
print "<BR>" ;
print scrolling_list( -name=>'choices',
                      -values=>['Select Command',
                                '*get all_config',
                                '*get pos_info',
                                '*get tracking_status',
                                '*get gps_hlth',
                                '*get utc_data',
                                '*get iono_data',
                                '*get agc',
                                'get alm_data 1',
                                'get eph_data 1',
                                '*get pdop_mask',
                                'put pdop_mask 7',
                                '*get pps_mode',
                                'put pps_mode on pos',
                                '*get event_mode',
                                'put event_mode on pos',
                                '*get l2_mode',
                                '*put l2_mode enigma',
                                '*put l2_mode l2c_or_enigma',
                                '*put l2_mode l2c_and_enigma',
                                '*put l2_mode off',
                                '*get waas_mode',
                                '*put waas_mode on',
                                '*put waas_mode off',
                                '*get waas_hlth',
                                '*get waas_sv_masks',
                                'put waas_sv_masks E E E E E E E E E E E E E E E E E E E',
                                '*get elev_mask',
                                'put elev_mask 10',
                                '*get pos_rate',
                                'put pos_rate 10',
                                '*get meas_rate',
                                'put meas_rate 10',
                                '*get sv_masks',
                                'put sv_masks E E E E E E E E E E E E E E E E E E E E E E E E E E E E E E E E',
                                '*get clock_steering',
                                'put clock_steering on',
                                '*get everest',
                                'put everest on',
                               ],
                      -size=>1,
                      -default=>'Select Command',
                      -onChange=>'newCommand()'
                    ) ;

########################################################################
# Javascript Functions
print <<endOfScripts ;
<Script>

/**********************************************************************/
function newCommand()
/**********************************************************************/
/* When a choice is made via the popup menus, this function is called.
 * A new URL is loaded of the states of the popups, to request the
 * specified data.
 */
{
  index = document.theForm.choices.selectedIndex  ;
  option = document.theForm.choices.options[index].value  ;
  if (option == 'Select Command') return ;

  //alert( "Choice:" + option ) ;
  if (option.charAt(0) == '*')
  {
    document.theForm.Command.value = option.substring(1) ;
    option = document.theForm.submit() ;
  }
  else
  {
    document.theForm.Command.value = option ;
  }


} /* end of newCommand() */

</SCRIPT>
endOfScripts
# End of Javascript Functions
########################################################################




print p(),submit( -name=>"Send", -value=>"Send" ) ;
print endform() ;



if ($command)
{
  print p(),"Command sent was <b> $command </b>" ;
# Open a socket to the Stinger task so that we can ask for the
# desired position information.
# The socket is available via a named socket file, which Stinger
# creates in /var/stinger.
# We attach to that and send requests down the pipe.  Ascii responses
# come back.  All lines are terminated with \n.  
# End of data indicated with "OK\n".

my $socketName = ($command =~ 'get ') 
                 ? '/var/stinger/info'
                 : '/var/stinger/config' ;
my $sun = sockaddr_un($socketName)|| die "no info";
socket(SOCK, PF_UNIX, SOCK_STREAM, PF_UNSPEC)|| die "socket: $!";
connect(SOCK,$sun)|| die "connect: $!";
SOCK->autoflush(1);

print (SOCK "$command\n") ;
# Response is of the form
#   167368.0, 1166:  37.3891508323 -122.034234235 -3.456
#   timetag   week#  Lat-degrees   Lon-degrees    Height-meters

print '<PRE>' ;

#$_ = <SOCK> ; print $_ ;
do {
  $_ = <SOCK> ; print $_ ;
} while ($_ !~ "OK" && $_ !~ "^ERROR" ) ;

print  '</PRE>' ;

close( SOCK ) ;
}


#print hr() ;

#print startform( -name=>"restartForm" ) ;
#print submit( -name=>"Restart", -value=>"Restart!" ),
#      "Restart Stinger!";
#print endform() ;
#
#if ($restart)
#{
#  print h3("Stinger Restarting") ;
#
#  # Run Stinger's init command with a restart request.
#  # Capture (some of) the output in a tmp file.
#  my $spid = qx( cat /var/run/frontpanel_task.pid ) ;
#  system( "/usr/bin/sudo /bin/kill -SIGUSR1 $spid" ) ;
#}

print hr() ;

print timestamp() ;

print end_html() ;
