#!/usr/bin/perl -w
# Copyright (c) 2002 Trimble Navigation Limited
# $Id: sysinfo.cgi,v 1.6 2004/06/15 18:07:54 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/sysinfo.cgi,v $

########################################################################
# sysinfo.cgi
#
# Provides a GUI interface to the 'sysinfo -p' command.
#
# Features a popup menu of known commands, and a text entry field to
# allow typing arbitrary modifications or parameters.
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;


titleWithHelp( 'Sysinfo',
                         '' # No Help
                       ) ;

my $command = '' ;

if (param())
{
  #print( "Parameters Received<BR>" ) ;
  #foreach my $p (param())
  #{
  #    print  "$p=", param($p), " " ;
  #}

  $command = param('Command') ;
}

my @sysinfoFileIDs ;

if (open( SYSINFO, '/usr/local/fireball/sysinfo |' ) )
{
  # Skip header of help info until we reach:
  #   File ID         Argument       Description
  while (<SYSINFO> !~ /^  File ID/){} ;

  $_ = <SYSINFO> ;  # Skip a blank line

  while (<SYSINFO>)
  {
    (my $fileID, undef) = split ;
    $fileID .= ' 1' if ( $fileID =~ m/eph_data|alm_data|app_version/) ;
    push( @sysinfoFileIDs, $fileID ) ;
  }
  close( SYSINFO ) ;
}

#print @sysinfoFileIDs ;


print startform( -name=>"theForm" ) ;
print submit( -name=>"Send", -value=>"Send" ) ;
print textfield( 'Command', 'name', 80, 80 ) ;
print "<BR>" ;
print scrolling_list( -name=>'choices',
                      -values=>\@sysinfoFileIDs,
                      -size=>1,
                      -onChange=>'newCommand()'
                    ) ;

########################################################################
# Javascript Functions
print <<endOfScripts ;
<Script>

/**********************************************************************/
function newCommand()
/**********************************************************************/
/* When a choice is made via the popup menus, this function is called.
 * A new URL is loaded of the states of the popups, to request the
 * specified data.
 */
{
  index = document.theForm.choices.selectedIndex  ;
  option = document.theForm.choices.options[index].value  ;

  document.theForm.Command.value = option ;
  document.theForm.submit() ;
} /* end of newCommand() */

</SCRIPT>
endOfScripts
# End of Javascript Functions
########################################################################




print endform() ;



if ($command)
{
  $command =~ s/;.*$// ;
  my $command = "sysinfo -p $command" ;

  print '<pre>' ;

  if ( open( SYSINFO, "/usr/local/fireball/$command |") )
  {
    while (<SYSINFO>)
    {
      print $_ ;
    }
    close( SYSINFO ) ;
  }
  print '</pre>' ;

}


print hr() ;

# Create Timestamp:
# 2001 Sep 6 - Thu of GPS Week 1130 - 17:46:52 GMT 
print timestamp() ;


########################################################################
print end_html() ;
########################################################################
