#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: syslogDownload.cgi,v 1.1 2004/10/04 18:01:12 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/syslogDownload.cgi,v $

########################################################################
# syslogDownload.cgi
# Script for downloading Fireball binary syslog files
# 
# It is activated via a pseudo-URL of the form:
#
#   http://netRSxxx/syslogDownload/logFilePath
#
# Such a URL is redirected by our web server (due to a ScriptAliasMatch
# configuration directive in httpd.conf) to call this script.  The
# full URL is available via the environment variable SCRIPT_NAME,
# which will look like:
#   
#   /syslogDownload/logFilePath
#
# In response, this script will extract the logFilePath and 
# download that file from /var/log/.  We use sendBinaryFile() to send
# the file with a non-existent "Content-Type" of "force_download".  That
# should pop up window on the user's browser asking where to store the
# data.  It is up to the browser to determine the suggested file name
# from the URL.  In general it should match logFilePath.
########################################################################

use strict ;
use CGI qw/:standard/;
use lib '..' ;
use Fireball ;


# Extract the name of the requested file from the environment
# variable.  We could also use REQUEST_URI, but that variable has 
# HTTP escaped characters still encoded.  The SCRIPT_NAME value should
# look something like:
#
#   /syslogDownload/logFilePath
#
# We'll drop the /syslogDownload/ portion and replace that with
# '/var/log/'.

my $path = $ENV{'SCRIPT_NAME'} ;
$path =~ s|^/syslogDownload/|/var/log/| ;
  
# Send back the requested file.  Do this with a technique that
# requests the client system to download and save the file.
sendBinaryFile( $path ) ;

########################################################################
# end of file syslogDownload.cgi
########################################################################
