#!/usr/bin/perl -w
# Copyright (c) 2003 Trimble Navigation Limited
# $Id: vsleep.cgi,v 1.6 2004/07/29 20:52:40 tom Exp $
# $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/perl-scripts/vsleep.cgi,v $

########################################################################
# vsleep.cgi
#
# Display and allow modification of the software shutdown voltage
# threshold (Vsleep).
# See the description in frontpanel_task.c for details.  (Look for 
# vsleep.)
########################################################################

use strict ;
use CGI qw/:standard/;
use Fireball ;


titleWithHelp( 'Shutdown Voltage',
               '/vsleepInfo.html'
             ) ;

my $vsleep = getVsleep() ;

my ($primaryVoltage, $secondaryVoltage, undef) = getVoltages() ;

my $highestVoltage = ($primaryVoltage > $secondaryVoltage)
                     ? $primaryVoltage
                     : $secondaryVoltage ;



# Create a data entry form.  The default action is to submit the
# parameters to the indicated script.
print startform( -name=>'theForm', 
                 -action=>'/perl-scripts/sysadmin/setVsleep.cgi',
                 -onSubmit=>'return Okay();'
               ) ;

print br(),
      'If both power supply input voltages are below this level, '
     .'then the NetRS will perform an automatic '
     .'shutdown.',
      br(), 
      br() ;

print table( Tr( td( {align=>"center"}, 
                     "Shutdown&nbsp;Threshold"
                   ), 
                 td( textfield( 'vsleep', 
                                sprintf( "%.3f", $vsleep ), 
                                10, 
                                10 
                              ) 
                   ),
                 td( 'Volts' ),
                 td( {width=>10} ),
                 td( button( -value=>"Default",
                             -onClick=>"Defaults() ;"
                           )
                   ),
               ) ,
             Tr( td( {align=>"center"},
                     "<font size=-1>min=10.68, max=11.4</font>" 
                   ),
                 td( {colspan=>3}, "" ),
                 td( {align=>"center"},
                     "<font size=-1>10.68</font>" 
                   ),
               )
           ) ;

print br(), br(),
      b('WARNING'),
      br() ;
printf "Setting the <i>Shutdown Threshold</i> too high can halt "
      ."this NetRS and may prevent proper operation.  Currently, "
      ."Power Input 1 is at %.3fV and Power Input 2 is at %.3fV",
       $primaryVoltage,
       $secondaryVoltage ;

print hr() ;

print p(),button( -name=>"OK", 
              -value=>"OK",
              -onClick=>"Okay() ;",
            ) ;
print "&nbsp;" ;
print button( -name=>'Cancel', 
              -value=>'Cancel',
              -onClick=>
            'parent.loadDataFrame( "/perl-scripts/rconfigDisplay.cgi" )'
            ) ;

print <<EOF ;
<Script>


/**********************************************************************/
function Okay()
/**********************************************************************/
/* Invoked when the OK button is pressed.
 * This checks the entry fields for validity and then submits the 
 * entire form with all parameters.
 */
{
  f = document.theForm ;

  // Check the fields here.
  // Only accept values of the forms   dd   dd.  dd.dd  .dd

  vsleep = f.vsleep.value = parent.strip( f.vsleep.value ) ;
  if ( parent.badFixedPointNumber( vsleep ) 
     )
  {
    alert( "Invalid numeric value." ) ;
    return false ;
  }

  if ( vsleep < 10.68
    || vsleep > 11.4
     )
  {
    alert( "Shutdown Threshold must be between 10.68v and 11.4v"
         ) ;
    return false ;
  }

  if ( $highestVoltage < vsleep 
    && !confirm( "Are you sure?\\n"
                +"That Shutdown Threshold will shutdown this NetRS."
               )
     )
  {
    return false ;
  }

  parent.submitForm( f, '' ) ;
  return false ;

} /* end of Okay() */


/**********************************************************************/
function Defaults()
/**********************************************************************/
/* Invoked when the Default button is pressed.
 * Sets the two Voltage Threshold input fields to their default values.
 */
{
  f = document.theForm ;

  f.vsleep.value = "10.680" ;
} /* end of Defaults() */


</Script>
EOF


print end_form() ;

print end_html() ;

########################################################################
# end of file masks.cgi
########################################################################
