/* $Id: progInfo.js,v 1.21 2006/03/23 19:55:23 tom Exp $
 * $Source: /home/CVS/fireballTop/fireballFS/root/usr/local/apache/htdocs/fireball/progInfo.js,v $
 *
 * A javascript include file for use in NetRS programmatic
 * help system.
 *
 */
CommandCount = 0 ;
CommandList = new Array() ;
CommandDesc = new Array() ;
CommandPage = new Array() ;

function addCommand( cmd, desc, page )
{
  CommandList[CommandCount] = cmd ;
  CommandDesc[CommandCount] = desc ;
  CommandPage[CommandCount] = page ;
  ++CommandCount ;
}

addCommand( "Show SystemName", 
            "Returns the System Name assigned to this NetRS.",
            "/progStatus.html"
          ) ;

addCommand( "Set SystemName", 
            "Modifies the System Name for this NetRS.",
            "/progStatus.html"
          ) ;

addCommand( "Show SerialNumber", 
            "Returns the Serial Number for this NetRS.",
            "/progStatus.html"
          ) ;

addCommand( "Show UtcTime", 
            "Returns the current UTC date and time.",
            "/progStatus.html"
          ) ;

addCommand( "Show Voltage", 
            "Returns the voltage on a power supply input.",
            "/progStatus.html"
          ) ;

addCommand( "Show Temperature", 
            "Returns the internal temperature of the NetRS.",
            "/progStatus.html"
          ) ;

addCommand( "Show Position", 
        "Returns the currently measured postion and associated values.",
            "/progStatus.html"
          ) ;

addCommand( "Show GpsTime", 
            "Returns the current GPS week number and time.",
            "/progStatus.html"
          ) ;

addCommand( "Show TrackingStatus",
            "Returns which satellites are being tracked.",
            "/progSatellites.html"
          ) ;

addCommand( "Show GpsHealth", 
            "Returns the health status of all GPS satellites.",
            "/progSatellites.html"
          ) ;

addCommand( "Show GpsSatControls", 
            "Returns the Enable/Disable/Ignorehealth settings for all GPS satellites.",
            "/progSatellites.html"
          ) ;


addCommand( "Set GpsSatControls", 
            "Modifies the Enable/Disable/Ignorehealth settings for GPS satellites.",
            "/progSatellites.html"
          ) ;

addCommand( "Show GpsEphemeris", 
            "Returns the Ephemeris data for a GPS satellite.",
            "/progSatellites.html"
          ) ;

addCommand( "Show GpsAlmanac", 
            "Returns the Almanac data for a GPS satellite.",
            "/progSatellites.html"
          ) ;

addCommand( "Show GpsUtcData", 
            "Returns the UTC data decoded from GPS satellites.",
            "/progSatellites.html"
          ) ;

addCommand( "Show GpsIonoData", 
            "Returns the Ionospheric Model data decoded from GPS satellites.",
            "/progSatellites.html"
          ) ;

addCommand( "Reset GpsData", 
            "Clears all decoded GPS Ephemeris and Almanac data.",
            "/progSatellites.html"
          ) ;

addCommand( "Show WaasTracking", 
            "Returns the control setting for tracking and use of WAAS satellites.",
            "/progSatellites.html"
          ) ;
addCommand( "Set WaasTracking", 
            "Enables or disables the tracking and use of WAAS satellites.",
            "/progSatellites.html"
          ) ;
addCommand( "Show WaasSatControls", 
            "Returns the Enable/Disable/Ignorehealth settings for all WAAS satellites.",
            "/progSatellites.html"
          ) ;
addCommand( "Set WaasSatControls", 
            "Modifies the Enable/Disable/Ignorehealth settings for WAAS satellites.",
            "/progSatellites.html"
          ) ;



addCommand( "Show LoggingStatus",
            "Returns the status of all defined logging sessions.",
            "/progSessions.html"
          ) ;

addCommand( "Show Sessions",
            "Returns the settings for ALL currently"
          + " defined data logging sessions.",
            "/progSessions.html"
          ) ;

addCommand( "Show Session",
            "Returns the settings for a specific data logging session.",
            "/progSessions.html"
          ) ;

addCommand( "Enable Session",
            "Enables a specific session.",
            "/progSessions.html"
          ) ;

addCommand( "Disable Session",
            "Disables a specific session.",
            "/progSessions.html"
          ) ;

addCommand( "Set Session",
            "Creates or modifies a data logging session.",
            "/progSessions.html"
          ) ;

addCommand( "Delete Session",
            "Deletes an existing data logging session.",
            "/progSessions.html"
          ) ;

addCommand( "Show AutoDelete",
            "Returns the current AutoDelete/Pool control settings.",
            "/progSessions.html"
          ) ;

addCommand( "Set AutoDelete",
            "Modifies the AutoDelete/Pool control settings.",
            "/progSessions.html"
          ) ;

addCommand( "Show PowerSaveMode",
            "Returns the current Power Saving Mode settings.",
            "/progSessions.html"
          ) ;

addCommand( "Set PowerSaveMode",
            "Modifies the Power Saving Shutdown mode.",
            "/progSessions.html"
          ) ;

addCommand( "Show FailsafeWakeup",
          "Returns the current settings for the Failsafe Wakeup Timer.",
            "/progSessions.html"
          ) ;

addCommand( "Set FailsafeWakeup", 
            "Changes the settings for the Failsafe Wakeup Timer.",
            "/progSessions.html"
          ) ;



addCommand( "Show LoggedFileStats", 
            "Returns the usage statistics for a data file directory.",
            "/progDataFiles.html"
          ) ;

addCommand( "Show LoggedFilePools", 
            "Returns the usage statistics for all data file pools.",
            "/progDataFiles.html"
          ) ;

addCommand( "Show LoggedFiles", 
            "Returns the contents of a data file directory.",
            "/progDataFiles.html"
          ) ;

addCommand( "Show LoggedFile", 
            "Returns the size of a specified data file.",
            "/progDataFiles.html"
          ) ;

addCommand( "Download LoggedFile", 
            "Downloads the contents of a specified data file.",
            "/progDataFiles.html"
          ) ;

addCommand( "Delete LoggedFiles", 
            "Removes the specified data file directory.",
            "/progDataFiles.html"
          ) ;

addCommand( "Delete LoggedFile", 
            "Removes the specified single data file.",
            "/progDataFiles.html"
          ) ;

                    
addCommand( "Reset System", 
            "Restarts (reboots) this NetRS system.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show ReferenceFrequency", 
            "Returns the current source for the 10MHz reference clock.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set ReferenceFrequency", 
            "Modifies the source for the 10MHz reference clock.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show ElevationMask", 
            "Returns the current Elevation Mask control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set ElevationMask", 
            "Modifies the Elevation Mask control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show PdopMask", 
            "Returns the current PDOP Mask control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set PdopMask", 
            "Modifies the PDOP Mask control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show ClockSteering", 
            "Returns the current Clock Steering control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set ClockSteering", 
            "Modifies the current Clock Steering control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show ShutdownVoltage", 
            "Displays the software shutdown voltage threshold.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set ShutdownVoltage", 
            "Modifies the software shutdown voltage threshold.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show L2C", 
            "Returns the current setting of the L2 tracking control.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set L2C", 
            "Modifies the setting of the L2 tracking control.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show L2Tracking", 
            "Returns the current setting of the L2 tracking control.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set L2Tracking", 
            "Modifies the setting of the L2 tracking control.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show MultipathReject", 
            "Returns the current Multipath Rejection control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set MultipathReject", 
            "Modifies the Multipath Rejection control setting.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show PPS", 
            "Returns the current settings of the Pulse-Per-Second controls.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set PPS", 
            "Modifies the settings of the Pulse-Per-Second controls.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show AntennaTypes", 
            "Returns a list of supported antenna types.",
            "/progConfiguration.html"
          ) ;

addCommand( "Show Antenna", 
            "Returns the current Antenna specifications.",
            "/progConfiguration.html"
          ) ;

addCommand( "Set Antenna", 
            "Modifies the Antenna specifications.",
            "/progConfiguration.html"
          ) ;




addCommand( "Show ConfigFiles", 
            "Returns the currently available Configuration Files and their sizes.",
            "/progConfigFiles.html"
          ) ;

addCommand( "Show ConfigFile", 
            "Returns the contents of a specific Configuration File.",
            "/progConfigFiles.html"
          ) ;

addCommand( "Create ConfigFile", 
            "Creates (or overwrites) a Configuration File.",
            "/progConfigFiles.html"
          ) ;

addCommand( "Delete ConfigFile", 
            "Removes an existing Configuration File.",
            "/progConfigFiles.html"
          ) ;

addCommand( "Upload ConfigFile", 
            "Uploads a Configuration File from an external computer.",
            "/progConfigFiles.html"
          ) ;

addCommand( "Install ConfigFile", 
            "Triggers the installation of a Configuration File.",
            "/progConfigFiles.html"
          ) ;




addCommand( "Show IOstatus", 
            "Returns the status of all active I/O channels.",
            "/progIO.html"
          ) ;

addCommand( "Show IOports", 
            "Returns all currently defined I/O ports and their settings.",
            "/progIO.html"
          ) ;

addCommand( "Show IOport", 
            "Returns the settings for a specific I/O port.",
            "/progIO.html"
          ) ;

addCommand( "Set IOport", 
            "Creates or modifies an I/O port setup.",
            "/progIO.html"
          ) ;

addCommand( "Delete IOport", 
            "Removes a TCP or UDP I/O port.",
            "/progIO.html"
          ) ;

addCommand( "Show RefStation", 
            "Returns the current Reference Station setup.",
            "/progIO.html"
          ) ;

addCommand( "Set RefStation", 
            "Modifies the Reference Station setup.",
            "/progIO.html"
          ) ;

addCommand( "Show ClientAuthKey", 
            "Returns the encoded Client Authetication Key.",
            "/progIO.html"
          ) ;

addCommand( "Set ClientAuthKey", 
            "Modifies the Client Authentication Key.",
            "/progIO.html"
          ) ;

addCommand( "Show PortAdvertising", 
            "Returns the current Port Advertising control settings.",
            "/progIO.html"
          ) ;

addCommand( "Set PortAdvertising", 
            "Modifies the Port Advertising controls.",
            "/progIO.html"
          ) ;

addCommand( "Show PppDialout", 
            "Returns the current settings for the PPP Dialout function.",
            "/progIO.html"
          ) ;

addCommand( "Set PppDialout", 
            "Modifies the PPP Dialout controls.",
            "/progIO.html"
          ) ;


addCommand( "Show Ethernet", 
            "Returns the current Ethernet settings.",
            "/progInternet.html"
          ) ;

addCommand( "Set Ethernet", 
            "Modifies the Ethernet settings.",
            "/progInternet.html"
          ) ;

addCommand( "Show FtpSetup", 
            "Returns the current FTP control settings.",
            "/progInternet.html"
          ) ;

addCommand( "Set FtpSetup", 
            "Modifies FTP control settings.",
            "/progInternet.html"
          ) ;

addCommand( "Show NtpClient", 
            "Returns control settings for the NTP client.",
            "/progInternet.html"
          ) ;

addCommand( "Set NtpClient", 
            "Modifies control settings for the NTP client.",
            "/progInternet.html"
          ) ;

addCommand( "Show HttpPorts", 
            "Returns control settings for HTTP & HTTPS ports.",
            "/progInternet.html"
          ) ;

addCommand( "Set HttpPorts", 
            "Modifies control settings for HTTP & HTTPS ports.",
            "/progInternet.html"
          ) ;

addCommand( "Show IpFiltering", 
            "Returns control settings for IP Filtering.",
            "/progInternet.html"
          ) ;

addCommand( "Set IpFiltering", 
            "Modifies control settings for IP Filtering.",
            "/progInternet.html"
          ) ;


addCommand( "Show GuiSecurity", 
            "Returns the current HTTP access restrictions.",
            "/progSecurity.html"
          ) ;

addCommand( "Set GuiSecurity", 
            "Modifies the HTTP access restrictions.",
            "/progSecurity.html"
          ) ;

addCommand( "Show GuiAccounts", 
            "Lists the currently defined HTTP access accounts.",
            "/progSecurity.html"
          ) ;

addCommand( "Show GuiAccount", 
            "Returns the settings for a specific HTTP access account.",
            "/progSecurity.html"
          ) ;

addCommand( "Set GuiAccount", 
            "Creates or modifies an HTTP access account.",
            "/progSecurity.html"
          ) ;

addCommand( "Delete GuiAccount", 
            "Removes an HTTP access account.",
            "/progSecurity.html"
          ) ;



addCommand( "Show FirmwareVersion", 
            "Returns the currently installed firmware version.",
            "/progFirmware.html"
          ) ;

addCommand( "Show FirmwareWarranty", 
            "Returns the current firmware warranty date.",
            "/progFirmware.html"
          ) ;

addCommand( "Set FirmwareWarranty", 
            "Updates the firmware warranty date.",
            "/progFirmware.html"
          ) ;

addCommand( "Upload FirmwareFile", 
            "Uploads a new firmware file.",
            "/progFirmware.html"
          ) ;

addCommand( "Show FirmwareFiles", 
            "Lists all uploaded firmware files.",
            "/progFirmware.html"
          ) ;

addCommand( "Show FirmwareFile", 
            "Returns information about a single firmware file.",
            "/progFirmware.html"
          ) ;

addCommand( "Verify FirmwareFile", 
            "Verifies the integrity of an uploaded firmware file.",
            "/progFirmware.html"
          ) ;

addCommand( "Install FirmwareFile", 
            "Installs an uploaded firmware file.",
            "/progFirmware.html"
          ) ;

addCommand( "Delete FirmwareFile", 
            "Deletes an uploaded firmware file.",
            "/progFirmware.html"
          ) ;

                    
/**********************************************************************/
function cmdRow( cmd )
/***********************************************************************
 * Used by the Help pages to easily format lists of commands and
 * their descriptions.  Emits a table-row of the form:
 *
 *    CommandName   Description..........
 *
 * CommandName is a link to the help page section for that command.
 ***********************************************************************
 */
{
  anchor = cmd ; 

  anchor = anchor.replace( / /g, "" ) ;

  for ( i = 0 ; i < CommandCount ; ++i )
  {
    if (CommandList[i] == cmd)
    {
      d = document ;
      d.writeln( "<tr>" ) ;
      d.writeln( '<td><a href="', 
                 CommandPage[i],
                 '#', anchor, '">',
                 cmd, '</a></td>' ) ;
      d.writeln( '<td>',CommandDesc[i], '</td>' ) ;
      d.writeln( "</tr>" ) ;
      break ;
    }
  }
} /* end of cmdRow() */

                    
/**********************************************************************/
function endSection( target )
/**********************************************************************/
/* Emits the html code to current document that produces a "top" link,
 * a "close" button, and a horizontal line.  This is designed to 
 * terminate a section in a uniform way.
 * If target is supplied as a non-empty string, a link target will be
 * placed just in front of the horizontal rule, using the target as
 * the name.
 */
{
  document.writeln( '<table width="100%" >' ) ;
  document.writeln( '<tr>' ) ;
  document.writeln( '<td align="left"><a href="#Top">Top</a></td>' ) ;
  document.writeln( '<td align="right">' ) ;
  document.writeln( '<form>' ) ;
  document.writeln( 
'<input type=Button name="close" value="Close" onclick="window.close()">' 
                  ) ;
  document.writeln( '</form>' ) ;
  document.writeln( '</tr>' ) ;
  document.writeln( '</table>' ) ;
  if (target != '')
  {
    document.writeln( '<a name="' + target + '"/>' ) ;
  }
  document.writeln( '<hr />' ) ;

} // end of topLink()
